     DEFINT A-Z
     rem $STATIC
     DIM SCR1(2000),SCR2(2000),SCR3(2000),SCR4(2000),SCR5(2000)

     rem $INCLUDE: 'COMDEF.BAS'

     PAGE=0
     LOCATE 23,1,0                                               ' locate and turn off the cursor
     CALL CALCATTR(MAG,BLACK,TIMATTR)                            ' set the color for the on-screen clock

     '---------------------------- set up the screen ------------------------

     ' Just for the heck of it, and because I want to do
     ' something different, we are going to 'clone' the
     ' QuickBASIC 2.0 opening screen, just to show what
     ' we can do.

     ' We begin by saving the current display screen
     ' and setting up the full-sized virtual screen that
     ' we'll draw the QB screen to.  This is not a scratch
     ' screen -- we'll use it throughout the progam.

     GOSUB SaveScreen                                            ' save the current screen in SCR1()
     DSEG=VARSEG(SCR2(1))                                        ' get address of virtual screen
     DOFS=VARPTR(SCR2(1))                                        ' get address of virtual screen
     CALL CALCATTR(GREEN,BLACK,ATTR)                             ' calculate the color attribute
     CALL DCLEAR(DSEG,DOFS,ATTR)                                 ' clear the virtual screen (CLS)
     CALL CALCATTR(BLACK,CYAN,ATTR)                              ' color for top line

     ' We use the window manager to draw the green
     ' frame and then imediately draw a smaller blue
     ' window inside without a window frame for the
     ' "editor".

     X=1 : Y=1 : A$=SPACE$(80) : GOSUB DXq                       ' clear the top line
     ULR=3 : ULC=2 : LRR=24  : LRC=79 : FRAME=2                  ' set loc for the green frame window
     FORE=GREEN : BACK=BLACK : GOSUB DWindowManager              ' draw the window
     ULR=4 : ULC=3 : LRR=23  : LRC=78 : FRAME=5                  ' now set up a smaller window with no frame
     FORE=GREY : BACK=BLUE   : GOSUB DWindowManager              ' to fit inside the first for the blue area

     ' we print the four black-on-green arrows...

     CALL CALCATTR(BLACK,GREEN,ATTR)                             ' calculate the color for the arrowheads
     X=25: Y=2  : A$=CHR$(27): GOSUB DXq                         ' print the four arrowheads
     Y=79: A$=CHR$(26)       : GOSUB DXq                         '  in the three corners...
     X=3 : Y=80 : A$=CHR$(24): GOSUB DXq
     X=24: A$=CHR$(25)       : GOSUB DXq

     ' and the wider bars on the bottom an right
     ' side...

     CALL CALCATTR(GREEN,BLACK,ATTR)                             ' the frame color
     A$=CHR$(176)                                                ' those two darker border position marks
     X=25: Y=3 : GOSUB DXq                                       ' on the bottom..
     X=4 : Y=80: GOSUB DXq                                       ' and the right...
     X=25: A$=CHR$(177)                                          ' the lighter border char
        FOR Y=4 TO 78 : GOSUB DXq : NEXT Y                       ' the bottom border line
     Y=80                                                        ' set the column to the far right
        FOR X=5 TO 23 : GOSUB DXq : NEXT X                       ' the right border line
     ULR=4 : ULC=12 : LRR=23 : LRC=68                            ' location of the white window
     WA=3  : WB=11  : WC=24  : WD=69                             ' allow for the frame for a partial virtual screen
     CALL CALCSIZE(WA,WB,WC,WD,ELEMENTS)                         ' calculate the size

     ' Since we will want to keep the basic
     ' QB screen, we'll draw the white window
     ' used in the inrtoduction to a second
     ' virtual screen.  Then, we can display
     ' it and then restore the QB screen with
     ' a single call.

     rem $DYNAMIC                                                ' set to dyanmic
     REDIM WIND1(ELEMENTS)                                       ' dimension the array
     W1SEG=VARSEG(WIND1(1))                                      ' get the address of the virtual screen
     W1OFS=VARPTR(WIND1(1))                                      ' get the address of the virtual screen
     TSEG=VARSEG(SCR3(1))                                        ' get the address of the virtual screen
     TOFS=VARPTR(SCR3(1))                                        ' get the address of the virtual screen
     FORE=RED : BACK=GREY : FRAME=2                              ' draw a window to the full-sized virtual screen
     CALL DWindowManager(TSEG,TOFS,ULR,ULC,LRR,LRC,FRAME,FORE,_
                         BACK,GROW,SHADOW,LABEL,LABEL$)
     CALL CALCATTR(BLUE,GREY,ATTR)                               ' set the text color
     Y=ULC+2                                                     ' the row to start with
        FOR X=ULR+1 TO ULR+7                                     ' loop thru the text.
           READ A$                                               ' reading...
           CALL DXQPRINT(TSEG,TOFS,A$,X,Y,ATTR)                  ' and writing to the virtual screen
        NEXT X
     ULR=X+3 : ULC=ULC+2 : LRR=ULR+4 : LRC=LRC-2 : FRAME=1       ' draw a small blue frame in the white window...
     FORE=BLUE : BACK=GREY
     CALL DWindowManager(TSEG,TOFS,ULR,ULC,LRR,LRC,FRAME,FORE,_
                         BACK,GROW,SHADOW,LABEL,LABEL$)
     X=X+2 : A$=CHR$(179)+" File and Disk Routines"+CHR$(179)    ' label it the way ms does
     Y=40-LEN(A$)\2                                              ' center it (integer divide!)
     CALL DXQPRINT(TSEG,TOFS,A$,X,Y,ATTR)                        ' print it
     Y=ULC+1 : I=X+1 : CALL CALCATTR(RED,GREY,ATTR)              ' set up to read text in the blue box
        FOR X=ULR TO ULR+4                                       ' loop...
           READ A$                                               ' read...
           CALL DXQPRINT(TSEG,TOFS,A$,X,Y,ATTR)                  ' print...
        NEXT X
     X=23 : CALL CALCATTR(BLUE,GREY,ATTR)                      ' calculate the color for the arrowheads
     A$=" Press any key or click either mouse button "
     Y=40-LEN(A$)\2                                              ' center it (integer divide!)
     CALL DXQPRINT(TSEG,TOFS,A$,X,Y,ATTR)                        ' write it
     CALL VGETSCREEN(TSEG,TOFS,WA,WB,WC,WD,W1SEG,W1OFS)          ' move the window from the full-sized to it's own vscreen...

     ' We have the QB screen in SCR2() and the white
     ' intro window in WIND1().  It's time to display
     ' them both.

     CALL DSCRREST(DSEG,DOFS,PAGE,SCRMODE)                       ' display the main screen
     CALL DPUTSCREEN(W1SEG,W1OFS,WA,WB,WC,WD,PAGE,SCRMODE)       ' overlay the white window in the second virtual screen

     ' We now have 2 virtual screens in memory, the
     ' main QB screen, and the white window. Rather
     ' than add the menu line to the virtual screen
     ' we'll just write it to the display screen.
     ' Then, with a single DPUTSCREEN we can restore
     ' the QB screen without the menu.  We're doing
     ' it that way so that after the joke is over,
     ' we can add the real menu line with a minimum
     ' of fuss and we save 2 calls by doing it
     ' this way.

     ' The next two lines of code are normally REMed out.
     ' They take a snapshot of the screen and save it to
     ' a file.  The file DEMO5.BAS uses this snapshot
     ' to draw its screen.  That way, we only need the code
     ' to create the screen in one file, not two.  Once the
     ' snapshot was taken, we stuck it in the SCRTEXT.DAT file
     ' with PIX1.BAS and REMed out these two lines.  We could
     ' just have easily let DEMO5.BAT read the DEMO2PIX.DAT file,
     ' but we wanted another example in PIX1.BAS.

'     FIL$="DEMO2PIX.DAT"
'     CALL SCR2FILE(FIL$,DSEG,DOFS,ECODE)

     CALL CALCATTR(BLACK,CYAN,ATTR)
        IF MONO THEN CALL CALCATTR(BLACK,GREY,ATTR)
     X=1 : Y=2
     A$=CHR$(240)+" File  Edit  View  Search  Run"+SPACE$(20) : GOSUB Xq
     CALL CALCATTR(GREEN,BLACK,ATTR)
     X=2 : Y=31
     A$=CHR$(179)+" HCSI ProBas 1.0 "+CHR$(179) : GOSUB Xq

     ' While the user reads the text in the intro window,
     ' we'll keep working and add the real bar menu to the
     ' virtual screen.

     ' Just as we did in DEMO1.BAS, we'll set up
     ' the arrays to store the bar menu data and
     ' write the choices to the bar on the virtual
     ' screen...

     REDIM MENU$(4),LMPOS(4),RMPOS(4),LASTROW(4),ELM(4)
     REDIM DSEG(4),DOFS(4),ULR(4),ULC(4),LRR(4),LRC(4)
     RESTORE BarMenuData                                         ' restore the data
        FOR I=1 TO 4                                             ' read for 8 choices
           READ MENU$(I)                                         ' menu choice text
           READ LMPOS(I),RMPOS(I)                                ' left col and right col
        NEXT I                                                   ' loop
     MAXMENU=4                                                   ' number of menu choices on bar
     CALL CALCATTR(BLACK,CYAN,ATTR)                              ' the color of the bar
        IF MONO THEN CALL CALCATTR(BLACK,GREY,ATTR)
     X=1 : Y=1 : A$=SPACE$(80) : GOSUB DXq                       ' clear the bar row, but not the frame...
     BAR.ROW=1                                                   ' remember the row the bar menu is on
        FOR I=1 TO 4                                             ' loop thru the choices
           Y=LMPOS(I)+1                                          ' set the location
           A$=MENU$(I) : GOSUB DXq                               ' read and write the choice
        NEXT I                                                   ' keep on truckin'

     ' We are going to draw the three pull-down menus while
     ' they are reading the initial text screen.  We have the
     ' basic QB screen in the array SCR2 (DSEG/DOFS).  We'll
     ' re-use the SRC3 (TSEG/TOFS) array for our full-size
     '  scratch screen, and draw the pull-downs there before
     ' shipping them off to MENU1() thru MENU4().  This is
     ' the same technique we narrated in DEMO1.BAS.  We'll
     ' use the VPUTSCREEN routine to copy the contents of
     ' SCR2() (the qb editor screen) to SCR3(), which will
     ' be our scratch area.

     CALL VPUTSCREEN(TSEG,TOFS,1,1,25,80,DSEG,DOFS)

     ' This series of For/Next loops reads data statements
     ' and uses them to compute the proper size and placement
     ' of each pull down menu.  Once the size and placement is
     ' known, the text choices for each menu is written to the
     ' scratch screen.  As each menu is completed, it is
     ' shipped to it's own virtual screen.

     ' In DEMO1.BAS we used 7 long routines to create 7 menus.
     ' As I mentioned in the narrative, we did it that way to
     ' allow us to examine each part as we came to it. This
     ' single 33 line routine does the exact same thing, in
     ' the same manner, using a tighter, more efficient design.
     ' The routine is designed in such a way that the menu
     ' choices can be expanded or changed by adding or
     ' subtracting data statements.

     RESTORE LastRowData
        FOR I=1 TO 3                                             ' read thru the number of menus
           READ LASTROW(I)                                       ' lastrow() is the physical bottom row of the...
        NEXT I                                                   ' ... particular menu.
     RESTORE Menu1Data                                           ' restore the menu choices starting with menu 1
        FOR I=1 TO 3                                             ' loop thru
           FOR J=3 TO LASTROW(I)                                 ' nested loop to read the choices for this menu,
              READ A$ : L=LEN(A$)                                ' find the widest meu choice and get the len
              IF L>LRC(I) THEN LRC(I)=LMPOS(I)+L+1               ' and set the right column so all choices fit in
           NEXT J                                                ' the window
           ULR(I)=3 : ULC(I)=LMPOS(I) : LRR(I)=LASTROW(I)        ' compute the rest or the window positions
           A=1 : B=ULC(I)-1 : C=LRR(I)+1 : D=LRC(I)+1            ' put into variables since we can't do math within a call
           CALL CALCSIZE(A,B,C,D,ELM(I))                         ' calculate the size for the virtual screen array
        NEXT I                                                   ' set up the four virtual screen arrays below
     REDIM MENU1(ELM(1)),MENU2(ELM(2)),MENU3(ELM(3))
     DSEG(1)=VARSEG(MENU1(1)): DOFS(1)=VARPTR(MENU1(1))
     DSEG(2)=VARSEG(MENU2(1)): DOFS(2)=VARPTR(MENU2(1))
     DSEG(3)=VARSEG(MENU3(1)): DOFS(3)=VARPTR(MENU3(1))
     RESTORE Menu1Data                                           ' restore the menu choice data again
          FOR I=1 TO 3                                           ' loop thru each of the four menus
           CALL VPUTSCREEN(TSEG,TOFS,1,1,25,80,DSEG,DOFS)        ' reset the scratch screen so that it has the Qb screen
           FORE=GREEN : BACK=BLACK : FRAME=4                     ' set and draw the menu window
           CALL DWindowManager(TSEG,TOFS,ULR(I),ULC(I),LRR(I),LRC(I),_
                               FRAME,FORE,BACK,GROW,SHADOW,LABEL,LABEL$)
           CALL CALCATTR(CYAN,BLACK,ATTR)                        ' colors for the bar menu highlight
           X=1 : Y=LMPOS(I)                                      ' set the x/y pos of the bar menu choice
           A$=" "+MENU$(I)+" "                                   '
           CALL DXQPRINT(TSEG,TOFS,A$,X,Y,ATTR)                  ' highlight the bar menu choice
           Y=ULC(I)+1 : CALL CALCATTR(WHITE,BLACK,ATTR)          ' set the y pos and color for the menu choices
              FOR X=3 TO LASTROW(I)                              ' loop thru this menu's rows
                  READ A$ : CALL DXQPRINT(TSEG,TOFS,A$,X,Y,ATTR) ' reading and writing the choice and
              NEXT X                                             ' til all choices are written
           A=1 : B=ULC(I)-1 : C=LRR(I)+1 : D=LRC(I)+1            ' get the virtual screens position from the arrays
           CALL VGETSCREEN(TSEG,TOFS,A,B,C,D,DSEG(I),DOFS(I))    ' ship the menu from the scratch screen to its own virtual
        NEXT I                                                   ' move on to the next menu

        IF MOUSE THEN
           CALL MMCURSORON                                       ' if a mouse, turn the mouse cursor on
           CALL SETMOUSELOC(13,40)                               ' and position in the middle
        END IF

     ' Our virtual screens are now done and we can
     ' now wait for the user to finish reading the
     ' first word on the screen.  Remember, drawing
     ' all of these screens took only a fraction of
     ' a second.

     CALL GETKEY3(MOUSE,CMD,CMD1,LFT,MID,RGT)

     ' We must be sure to turn the mouse cursor off
     ' before restoring a screen so that the character
     ' where the mouse cursor is will be restored.  We
     ' then turn the cursor back on when we are ready.
     ' After the key or click, we'll restore the blank
     ' QB screen, write a few lines of help text, and
     ' move onto the main input routine.

         IF MOUSE THEN CALL MMCURSOROFF                          ' turn mouse cusor off for restore
     CALL DSCRREST(DSEG,DOFS,PAGE,SCRMODE)                       ' restore the QB screen
     CALL CALCATTR(GREY,BLUE,ATTR)                               ' set the text color
     Y=4 : RESTORE Help1Data                                     ' set the y pos and restore the data
        FOR X=4 TO 17                                            ' loop thru the lines..
           READ A$ : GOSUB Xq                                    ' reading and writing
        NEXT X                                                   ' til done
     CALL GETKEY3(MOUSE,CMD,CMD1,LFT,MID,RGT)                    ' wait for a click then kill the help text
     CALL DSCRREST(DSEG,DOFS,PAGE,SCRMODE)                       ' restore the qb screen to erase the text
        IF MOUSE THEN GOSUB SetBarMouse                          ' set the mouse range to the bar only
     OROW=BAR.ROW : NROW=OROW                                    ' the row the menu bar is on
     OLPOS=LMPOS(1) : ORPOS=RMPOS(1)                             ' the position of the old highlight
     NLPOS=LMPOS(1) : NRPOS=RMPOS(1)                             ' the position of the new highlight
     GOSUB ReColorHighlight                                      ' set the highlight
     BARPOS=1 : BARPOSAVE=1                                      ' save the pos of highlight
     MENU=0                                                      ' no pull-down menu yet selected

     ' Note: Before you think too unkindly of me, I just
     '       want you to know that I realize that most
     '       of the following code is duplicated to a great
     '       extent in each of the overlays and that it
     '       wastes a lot of disk space.  Please remember
     '       that the idea behind the structure of this code
     '       is not to be the most efficient, but rather the
     '       most illustrative and easily narrated.  Were
     '       this a commercial program, that did something
     '       other than show you how to use various ProBas
     '       routines, I would have structured the whole
     '       thing quite differently.

     ' With that disclaimer out of the way, we can continue.
     ' This is the heart of the program, where almost
     ' all input and mouse movement is handled.  We are
     ' really dealing here with multiple menus, that have
     ' to be handled differently,  the bar menu has to
     ' be handled one way, and the pull-downs handled a
     ' bit differently.

     ' The real trick to a routine like this is to allow
     ' the user to move the highlight with either the
     ' arrow keys or the mouse, and not have them fight
     ' with one another.  If the user uses an arrow key,
     ' the mouse must be informed or on the next loop the
     ' mouse routines will try to undo what the arrow
     ' keys just did.

     ' When the bar menu is active, we set the mouse to
     ' just the area of the bar and note the horizontal
     ' movements.  If a pull-down is active, the mouse
     ' is set to the area of the pull-down and we note
     ' the vertical movements.

     '------------------------------ main command ---------------------------

MainCom:                                                         ' the main keyboard/mouse input routine
     CLOCKOFF=0                                                  ' set the clock display back on in case it was turned off
        DO                                                       ' wait for a keypress or a mouse click
           CALL CHECKKEY3(MOUSE,CMD,CMD1,LFT,MID,RGT)            ' check for keypress or mouse click
              IF MOUSE THEN GOSUB MoveBarMouse                   ' check to see if the mouse has been moved
           CLICK=(CMD OR CMD1 OR LFT OR MID OR RGT)              ' if a keypress or mouse click then exit the while/wend loop
        LOOP UNTIL CLICK                                         ' keep on truckin'
        IF CMD1=80 AND MENU<>0 THEN                              ' down arrow  - move highlight down in menu
           GOSUB MoveHiDown
        ELSEIF CMD1=72 AND MENU<>0 THEN                          ' up arrow    - move highlight up in menu
           GOSUB MoveHiUp
        ELSEIF MENU=0 AND CMD1=77 THEN                           ' right arrow - move right one choice on bar
           GOSUB MoveHiRight
        ELSEIF MENU=0 AND CMD1=75 THEN                           ' left arrow  - move left one choice on bar
           GOSUB MoveHiLeft
        ELSEIF LFT<>0 OR CMD=13 THEN                             ' they pressed Enter or clicked left button
           GOTO CheckChoice
        ELSEIF RGT<>0 AND MENU<>0 THEN                           ' click right button to exit pull-down
           GOSUB ResetBar
        ELSEIF CMD=27 AND MENU<>0 THEN                           ' they exited the pull-down menu so reset the bar menu
           GOSUB ResetBar
        ELSEIF CMD=27 THEN                                       ' if ESC then end
           GOTO Quit
        END IF
     GOTO MainCom                                                ' keep checking for input

MoveBarMouse:
     CALL GETMOUSELOC(MROW,MCOL)                                 ' get the current mouse location
        IF MROW=SROW AND MCOL=SCOL THEN RETURN                   ' the mouse has not moved since we last checked
        IF MENU<>0 THEN GOTO MenuMouse                           ' we have a menu active so we're not on the bar
        IF MROW<>BAR.ROW THEN GOTO MenuMouse                     ' remember that NOT MENU only works if MENU=-1
BarM2:
        IF MCOL>LMPOS(BARPOS) THEN GOSUB MoveHiRight : RETURN    ' move right one bar choice
        IF MCOL<RMPOS(BARPOS) THEN GOSUB MoveHiLeft  : RETURN    ' move left  one bar choice
     RETURN

MenuMouse:
        IF MROW<ULR(MENU) THEN GOSUB ResetBar : RETURN           ' mouse moved out of the pull-down so back to bar menu
        IF MROW>MENPOS+2 THEN GOSUB MoveHiDown: RETURN           ' mouse moved down 1 row or more
        IF MROW<MENPOS+2 THEN GOSUB MoveHiUp  : RETURN           ' mouse moved up 1 row or more
     RETURN

ResetBar:
     A=1 : B=ULC(MENU)-1 : C=LRR(MENU)+1 : D=LRC(MENU)+1
     XSEG=VARSEG(SCR3(1)): XOFS=VARPTR(SCR3(1))                  ' get the address of the saved screen
     CALL DPUTSCREEN(XSEG,XOFS,A,B,C,D,PAGE,SCRMODE)             ' restore the area that was overwritten by menu
        IF MOUSE THEN GOSUB RB2                                  ' set the mouse range for the menu bar
     MENPOS=0 : MENPOSAVE=0                                      ' clear the pull-down menu locations
     MENU=0                                                      ' set the menu flag to no menu
     RETURN
RB2: GOSUB SetBarMouse                                           ' set the mouse range for the bar
     CALL SETMOUSELOC(BAR.ROW,LMPOS(BARPOS))                     ' set the mouse location
     MROW=BAR.ROW : MCOL=LMPOS(BARPOS)                           ' reset the mouse pointers...
     SROW=MROW    : SCOL=MCOL                                    ' old and new
     RETURN

DisplayMenu:
     MENU=BARPOS
        IF MENU=4 THEN GOTO Quit                                 ' the Quit choice has no menu!
     DSEG=DSEG(MENU)                                             ' pull the data seg...
     DOFS=DOFS(MENU)                                             ' and offset from storage array
     A=1 : B=ULC(MENU)-1 : C=LRR(MENU)+1 : D=LRC(MENU)+1
     XSEG=VARSEG(SCR3(1)): XOFS=VARPTR(SCR3(1))                  ' get the address of the saved screen
     CALL DGETSCREEN(XSEG,XOFS,A,B,C,D,PAGE,SCRMODE)             ' take a snapshot the area that will be overwritten
     CALL DPUTSCREEN(DSEG(MENU),DOFS(MENU),A,B,C,D,PAGE,SCRMODE) ' ship menu from virtual to active screen
     OROW=ULR(MENU)  : NROW=OROW                                 ' set the row for the highlight
     OLPOS=ULC(MENU) : ORPOS=LRC(MENU)                           ' set the save columns
     NLPOS=ULC(MENU) : NRPOS=LRC(MENU)                           ' set the left/right sides of the highlight
        IF MOUSE THEN GOSUB SetMenuMouse                         ' set the mouse range and loc for pull-down
     GOSUB ReColorHighlight                                      ' highlight first choice in pull-down
     MENPOS=1 : MENPOSAVE=1                                      ' set the highlight pos for the vertical menu to 1
     RETURN

MoveHiDown:
        IF MENPOS+2 = LASTROW(MENU) THEN RETURN                  ' we are at the bottom menu choice
     CALL CALCATTR(LCYAN,BLACK,HMATTR)                           ' set the menu text color
     MENPOS=MENPOS+1                                             ' increment the pointer
     OROW=MENPOSAVE+2                                            ' set the old position
     NROW=MENPOS+2                                               ' set the new position
     OLPOS=ULC(MENU) : ORPOS=LRC(MENU)                           ' set the left and right columns
     NLPOS=ULC(MENU) : NRPOS=LRC(MENU)                           ' old and new...
     GOSUB ReColorHighlight                                      ' move the highlight
     MENPOSAVE=MENPOS                                            ' reset the pointer to the current position
        IF MOUSE THEN                                            ' if a mouse then feed it the new position
           CALL SETMOUSELOC(NROW,ULC(MENU))
           MROW=BROW : MCOL=ULC(MENU)
           SROW=MROW : SCOL=MCOL
        END IF
     RETURN                                                      ' done

MoveHiUp:
        IF MENPOS=1 THEN GOTO ResetBar                           ' close the pull-down and rest the menu bar
     CALL CALCATTR(LCYAN,BLACK,HMATTR)                           ' set the color
     MENPOS=MENPOS-1                                             ' decrement the pointer
     OROW=MENPOSAVE+2                                            ' set the old position
     NROW=MENPOS+2                                               ' set the new position
     OLPOS=ULC(MENU) : ORPOS=LRC(MENU)                           ' set the old left and right columns
     NLPOS=ULC(MENU) : NRPOS=LRC(MENU)                           ' set the new left and right columns
     GOSUB ReColorHighlight                                      ' move the highlight
     MENPOSAVE=MENPOS                                            ' reset the pointer
        IF MOUSE THEN                                            ' feed that hungry mouse
           CALL SETMOUSELOC(NROW,ULC(MENU))
           MROW=BROW : MCOL=ULC(MENU)
           SROW=MROW : SCOL=MCOL
        END IF
     RETURN                                                      ' done

MoveHiRight:
     CALL CALCATTR(LCYAN,MAG,HMATTR)                             ' set the colors
        IF MONO THEN CALL CALCATTR(GREY,BLACK,HMATTR)            ' default doesn't look good in mono so change them
        IF BARPOS=5 THEN GOTO MainCom                            ' if we're at the end, return (or we could wrap by setting it to 1)
     BARPOS=BARPOS+1                                             ' increment the pointer
     OROW=BAR.ROW : NROW=OROW                                    ' set the row
     OLPOS=LMPOS(BARPOSAVE): ORPOS=RMPOS(BARPOSAVE)              ' set the old left/right columns
     NLPOS=LMPOS(BARPOS)   : NRPOS=RMPOS(BARPOS)                 ' set the new left/right columns
     GOSUB ReColorHighlight                                      ' move the highlight
     BARPOSAVE=BARPOS                                            ' update the position pointer
        IF MOUSE THEN                                            ' feed the mouse the new position info
           CALL SETMOUSELOC(BAR.ROW,LMPOS(BARPOS))
           MROW=BAR.ROW : MCOL=LMPOS(BARPOS)
           SROW=MROW : SCOL=MCOL
        END IF
     RETURN                                                      ' done

MoveHiLeft:
     CALL CALCATTR(LCYAN,MAG,HMATTR)                             ' set the color
        IF MONO THEN CALL CALCATTR(GREY,BLACK,HMATTR)            ' default doesn't look good in mono so change them
        IF BARPOS=1 THEN GOTO MainCom                            ' if full left then we can't go any farther, return
     BARPOS=BARPOS-1                                             ' decrement the pointer
     OROW=BAR.ROW : NROW=OROW                                    ' set the row
     OLPOS=LMPOS(BARPOSAVE): ORPOS=RMPOS(BARPOSAVE)              ' set the old left/right columns
     NLPOS=LMPOS(BARPOS)   : NRPOS=RMPOS(BARPOS)                 ' set the new left/right columns
     GOSUB ReColorHighlight                                      ' move the highlight
     BARPOSAVE=BARPOS                                            ' update the position pointer
        IF MOUSE THEN                                            ' feed the mouse the new position info
           CALL SETMOUSELOC(BAR.ROW,LMPOS(BARPOS))
           MROW=BAR.ROW : MCOL=LMPOS(BARPOS)
           SROW=MROW : SCOL=MCOL
        END IF
     RETURN                                                      ' done

CheckChoice:
        IF BARPOS=4 THEN GOTO Quit                               ' the Quit choice
        IF MENU=0 THEN GOSUB DisplayMenu : GOTO MainCom          ' they selected a pull-down menu

     ON MENU GOTO Menu1,Menu2,Menu3

Menu1:
     GOSUB SaveScreen4                                           ' save the screen
     RESTORE Menu1Descriptions                                   ' restore the menu choice descriptions
     GOSUB GetAndDisplayText                                     ' the label says it all...
     GOTO MainCom

Menu2:
     GOSUB SaveScreen4                                           ' save the screen
     RESTORE Menu2Descriptions                                   ' restore the menu choice descriptions
     GOSUB GetAndDisplayText                                     ' the label says it all...
     GOTO MainCom

Menu3:
     GOSUB SaveScreen4                                           ' save the screen
     RESTORE Menu3Descriptions                                   ' restore the menu choice descriptions
     GOSUB GetAndDisplayText                                     ' the label says it all...
     GOTO MainCom

     '---------------- get and display menu choice descriptions -------------

GetAndDisplayText:
        FOR J=1 TO MENPOS                                        ' read thru the data statements...
           READ A$                                               ' til we reach the one we want...
        NEXT J                                                   ' now we have it!
     REDIM A$(20)                                                ' set up an array for text descriptions
     INDEX=0                                                     ' clear pointer
     DELIM$="|"                                                  ' specify the delimiter
        DO                                                       ' loop
           INDEX=INDEX+1                                         ' increment the pointer
           CALL EXTRACT(A$,DELIM$,INDEX,ST,SLEN)                 ' do the call
           A$(INDEX)=MID$(A$,ST,SLEN)                            ' load the delimited string into array
        LOOP WHILE SLEN                                          ' loop til done
     SS=SCRMODE : SCRMODE=0                                      ' save the mode and force it to slow for a growing window
     WROW=MENPOS+3                                               ' set the row
     WCOL=LRC(MENU)+3                                            ' column relative to the highlighted pull-menu choice
     X=WROW : Y=WCOL+1                                           ' set the text position in the window we will draw
     UR=WROW : UC=WCOL : LR=UR+INDEX-2 : LC=UC+31                ' use different variables so we don't mess up the menu vars!
        IF LR>24 THEN UR=25-INDEX : LR=UR+INDEX-2 : X=UR         ' make sure the window stays on the screen
     F=LRED  : B=MAG   : FR=2 : GROW=-1                          ' use a growing window for giggles
     CALL WindowManager(UR,UC,LR,LC,FR,F,B,_
                        GROW,SHADOW,LABEL,LABEL$,PAGE,SCRMODE)   ' draw the window
     SCRMODE=SS : SS=0                                           ' reset the screen mode (fast/slow)
     CALL CALCATTR(WHITE,MAG,ATTR)                               ' set the color for the text in the window
        FOR J=1 TO INDEX                                         ' loop thru the array
           A$=A$(J) : GOSUB Xq                                   ' write the text
           X=X+1                                                 ' increment the row pointer for text
        NEXT J                                                   ' loop til done
     X=25 : CALL CALCATTR(BLACK,GREEN,ATTR)
        IF MOUSE THEN
           A$=" Click the right button for a demo "
        ELSE
           A$=" Press the space bar for a demo "
        END IF
     Y=40-LEN(A$)\2 : GOSUB Xq                                   ' center it
        DO                                                       ' wait for a key or click...
           CALL CHECKKEY3(MOUSE,CMD,CMD1,LFT,MID,RGT)            ' in a little loop...
           CLICK=(CMD OR CMD1 OR LFT OR MID OR RGT)              ' and the time won't droop.
        LOOP UNTIL CLICK                                         ' poetic, ain't I? (gag!)
     ERASE A$:A$="":DELIM$="":INDEX=0:ST=0:SLEN=0:J=0:L=0:R=0    ' clear all these garbage variables
     WROW=0:WCOL=0:UR=0:UC=0:LR=0:LC=0:F=0:B=0:FR=0              ' clear these too, they're disposable
        IF RGT THEN GOTO Demos                                   ' right button - they asked for a demo
        IF CMD=32 THEN GOTO Demos                                ' space bar    - they asked for a demo
     GOSUB RestoreScreen4                                        ' restore the screen snapshot
     RETURN                                                      ' we're all done here

Demos:
     SELECT CASE MENU
        CASE 1: GOSUB Menu1Demo
        CASE 2: GOSUB Menu2Demo
        CASE 3: GOSUB Menu3Demo
        CASE ELSE
     END SELECT
     X=25 : CALL CALCATTR(BLACK,GREEN,ATTR)
       IF MOUSE THEN
          A$=" Click either mouse button for menu "
       ELSE
          A$=" Press any key to return to the menu "
       END IF
     Y=40-LEN(A$)\2 : GOSUB Xq
     CALL GETKEY3(MOUSE,CMD,CMD1,LFT,MID,RGT)
     GOSUB RestoreScreen4                                        ' restore the screen snapshot
     RETURN                                                      ' we're all done here

     '---------------------------- menu 1 demos -----------------------------

Menu1Demo:
     SELECT CASE MENPOS
        CASE 1 : GOSUB M1d1
        CASE 2 : GOSUB M1d2
        CASE 3 : GOSUB M1d3
        CASE 4 : GOSUB M1d4
        CASE 5 : GOSUB M1d5
        CASE 6 : GOSUB M1d6
        CASE 7 : GOSUB M1d7
        CASE 8 : GOSUB M1d8
        CASE 9 : GOSUB M1d9
        CASE 10: GOSUB M1d10
        CASE 11: GOSUB M1d11
        CASE 12: GOSUB M1d12
        CASE ELSE
     END SELECT
     RETURN

M1d1:
     DRV$=" " : CALL GETDRV(DRV$)
     CALL DISKSTAT(DRV$,FREE.CLUST,TOTAL.CLUST,BYTES.SEC,SECS.CLUST)
     CLUSTER.SIZE# = CDBL(BYTES.SEC) * CDBL(SECS.CLUST)
     FREE.DISK.SPACE# = CDBL(FREE.CLUST) * CLUSTER.SIZE#
     TOTAL.DISK.SPACE# = CDBL(TOTAL.CLUST) * CLUSTER.SIZE#

     CALL CALCATTR(GREY,BLUE,ATTR) : Y=2
     X=18: A$="Example:" : GOSUB Xq: Y=7
     X=19: A$="CALL DISKSTAT(DRV$,FREE.CLUST,TOTAL.CLUST,BYTES.SEC,SECS.CLUST)" : GOSUB Xq
     X=20: A$="CLUSTER.SIZE# = CDBL(BYTES.SEC) * CDBL(SECS.CLUST)"    : GOSUB Xq
     X=21: A$="FREE.DISK.SPACE# = CDBL(FREE.CLUST) * CLUSTER.SIZE#"   : GOSUB Xq
     X=22: A$="TOTAL.DISK.SPACE# = CDBL(TOTAL.CLUST) * CLUSTER.SIZE#" : GOSUB Xq
     ULR=6 : ULC=55 : LRR=12 : LRC=77 : FRAME=2
     FORE=RED : BACK=GREY : GROW=-1 : SHADOW=-1
     LABEL=BLUE : LABEL$="Sample Output"
     GOSUB WindowManager
     CALL CALCATTR(BLUE,GREY,ATTR): Y=ULC
     X=ULR: A$="DRV$       : "+DRV$ : GOSUB Xq
     X=X+1: A$="FREE.CLUST :"+STR$(FREE.CLUST)       : GOSUB Xq
     X=X+1: A$="TOTAL.CLUST:"+STR$(TOTAL.CLUST)      : GOSUB Xq
     X=X+1: A$="BYTES.SEC  :"+STR$(BYTES.SEC)        : GOSUB Xq
     X=X+1: A$="SECS.CLUST :"+STR$(SECS.CLUST)       : GOSUB Xq
     X=X+1: A$="Free  space:"+STR$(FREE.DISK.SPACE#) : GOSUB Xq
     X=X+1: A$="Total space:"+STR$(TOTAL.DISK.SPACE#): GOSUB Xq
     RETURN

M1d2:
     DRV$=" " : CALL GETDRV(DRV$)
     CALL DRVSPACE(DRV$,A,B,C)
     FREESPACE#=CDBL(A)*CDBL(B)*CDBL(C)

     CALL CALCATTR(GREY,BLUE,ATTR) : Y=2
     X=18: A$="Example:" : GOSUB Xq: Y=7
     X=19: A$="DRV$ = "+CHR$(34)+DRV$+CHR$(34)    : GOSUB Xq
     X=20: A$="CALL DRVSPACE(DRV$,A,B,C)"         : GOSUB Xq
     X=21: A$="FREESPACE#=CDBL(A)*CDBL(B)*CDBL(C)": GOSUB Xq
     CALL CALCATTR(WHITE,BLUE,ATTR)
     X=23: A$="FREESPACE# ="+STR$(FREESPACE#)     : GOSUB Xq
     RETURN

M1d3:
     ULR=15 : ULC=44 : LRR=20 : LRC=77 : FRAME=2
     FORE=RED : BACK=GREY : GROW=-1 : SHADOW=-1
     GOSUB WindowManager
     CALL CALCATTR(BLUE,GREY,ATTR): Y=ULC
     X=ULR: A$="Enter the full filespec of a file." : GOSUB Xq
     X=X+1: A$="If you don't remember one offhand," : GOSUB Xq
     X=X+1: A$="press the Enter key and we'll use"  : GOSUB Xq
     X=X+1: A$="DEMO2.OVL on the current drive."    : GOSUB Xq
     X=X+2: COLOR BLUE,WHITE
     LOCATE X,Y,1 : INPUT "Spec: ",SPEC$
     CALL UPCASE(SPEC$)
        IF LEN(SPEC$)=0 THEN SPEC$="DEMO2.OVL"
     CALL CALCATTR(GREY,BLUE,ATTR) : Y=2
     X=18: A$="Example:" : GOSUB Xq: Y=7
     X=19: A$="FIL$="+CHR$(34)+SPEC$+CHR$(34) : GOSUB Xq
     X=20: A$="CALL EXIST(FIL$,FOUND)" : GOSUB Xq
     CALL EXIST(SPEC$,FOUND)
     CALL CALCATTR(WHITE,BLUE,ATTR)
     X=22: A$="Spec  = "+SPEC$      : GOSUB Xq
     X=23: A$="FOUND = "+STR$(FOUND) : GOSUB Xq
     CALL CALCATTR(GREY,BLUE,ATTR)
     X=24: A$="rem -1 = found    0 = not found" : GOSUB Xq
     RETURN

M1d4:
     ULR=15 : ULC=44 : LRR=20 : LRC=77 : FRAME=2
     FORE=RED : BACK=GREY : GROW=-1 : SHADOW=-1
     GOSUB WindowManager
     CALL CALCATTR(BLUE,GREY,ATTR): Y=ULC
     X=ULR: A$="Enter the name a directory. If you" : GOSUB Xq
     X=X+1: A$="can't think of one off-hand, press" : GOSUB Xq
     X=X+1: A$="Enter and we'll use \PROBAS on the" : GOSUB Xq
     X=X+1: A$="current drive."                     : GOSUB Xq
     X=X+2: COLOR BLUE,WHITE
     LOCATE X,Y,1 : INPUT "Directory: ",SUBDIR$
     CALL UPCASE(SUBDIR$)
        IF LEN(SUBDIR$)=0 THEN SUBDIR$="\PROBAS"
     CALL CALCATTR(GREY,BLUE,ATTR) : Y=2
     X=18: A$="Example:" : GOSUB Xq: Y=7
     X=19: A$="SUBDIR$="+CHR$(34)+SPEC$+CHR$(34) : GOSUB Xq
     X=20: A$="CALL SUBEXIST(SUBDIR$,VALID)" : GOSUB Xq
     CALL SUBEXIST(SUBDIR$,VALID)
     CALL CALCATTR(WHITE,BLUE,ATTR)
     X=22: A$="Directory = "+SUBDIR$   : GOSUB Xq
     X=23: A$="VALID     = "+STR$(VALID): GOSUB Xq
     CALL CALCATTR(GREY,BLUE,ATTR)
     X=24: A$="rem -1 = valid    0 = not valid" : GOSUB Xq
     RETURN

M1d5:
     CALL CALCATTR(GREY,BLUE,ATTR) : Y=2
     X=18: A$="Example:" : GOSUB Xq: Y=7
     X=19: A$="DRV$="+CHR$(34)+" "+CHR$(34)   : GOSUB Xq
     X=20: A$="CALL GETDRV(DRV$)" : GOSUB Xq
     DRV$=" " : CALL GETDRV(DRV$)
     CALL CALCATTR(WHITE,BLUE,ATTR)
     X=22: A$="Drive = "+DRV$    : GOSUB Xq
     RETURN

M1d6:
     CALL CALCATTR(GREY,BLUE,ATTR) : Y=2
     X=18: A$="Example:" : GOSUB Xq: Y=7
     X=19: A$="DRV$="+CHR$(34)+"C"+CHR$(34)  : GOSUB Xq
     X=20: A$="CALL SETDRV(DRV$,ECODE)" : GOSUB Xq
     X=22: A$="rem  - an example only.  No drive was set in demo." : GOSUB Xq
     RETURN

M1d7:
     CALL CALCATTR(GREY,BLUE,ATTR) : Y=2
     X=18: A$="Example:" : GOSUB Xq: Y=7
     X=19: A$="SUB$ = SPACE$(64)" : GOSUB Xq
     X=20: A$="CALL GETSUB(SUB$,SLEN)" : GOSUB Xq
     X=21: A$="SUB$ = "+CHR$(34)+"\"+CHR$(34)+" + LEFT$(SUB$,SLEN) ": GOSUB Xq
     SUB$=SPACE$(64)
     CALL GETSUB(SUB$,SLEN)
     SUB$="\"+LEFT$(SUB$,SLEN)
     CALL CALCATTR(WHITE,BLUE,ATTR)
     X=23: A$="Subdirectory = "+SUB$ : GOSUB Xq
     RETURN

M1d8:
     CALL CALCATTR(GREY,BLUE,ATTR) : Y=2
     X=18: A$="Example:" : GOSUB Xq: Y=7
     X=19: A$="SUB$ = "+CHR$(34)+"C:\AN\EXAMPLE\ONLY"+CHR$(34) : GOSUB Xq
     X=20: A$="CALL SETSUB(SUB$,ECODE)"   : GOSUB Xq
     X=22: A$="rem  - if ecode returned non-zero, the subdirectory": GOSUB Xq
     X=23: A$="rem  - was NOT set." : GOSUB Xq
     RETURN

M1d9:
     CALL CALCATTR(GREY,BLUE,ATTR) : Y=2
     X=18: A$="Example:" : GOSUB Xq: Y=7
     X=19: A$="SUB$ = "+CHR$(34)+"C:\AN\EXAMPLE\ONLY"+CHR$(34) : GOSUB Xq
     X=20: A$="CALL DELSUB(SUB$,ECODE)"   : GOSUB Xq
     X=22: A$="rem  - if ecode returned non-zero, the routine" : GOSUB Xq
     X=23: A$="rem  - was unable to delete the subdirectory"   : GOSUB Xq
     RETURN

M1d10:
     CALL CALCATTR(GREY,BLUE,ATTR) : Y=2
     X=18: A$="Example:" : GOSUB Xq: Y=7
     X=19: A$="SUB$ = "+CHR$(34)+"C:\AN\EXAMPLE\ONLY"+CHR$(34) : GOSUB Xq
     X=20: A$="CALL MAKESUB(SUB$,ECODE)"   : GOSUB Xq
     X=22: A$="rem  - if ecode returned non-zero, the routine" : GOSUB Xq
     X=23: A$="rem  - was unable to create the subdirectory"   : GOSUB Xq
     RETURN

M1d11:
     CALL CALCATTR(GREY,BLUE,ATTR) : Y=2
     X=18: A$="Example:" : GOSUB Xq: Y=7
     X=19: A$="OLDNAME$="+CHR$(34)+"TEST.TXT"+CHR$(34) : GOSUB Xq
     X=20: A$="NEWNAME$="+CHR$(34)+"TEST.NEW"+CHR$(34) : GOSUB Xq
     X=21: A$="CALL RENAME(OLDNAME$,NEWNAME$,ECODE)" : GOSUB Xq
     X=23: A$="rem  - example only no file was renamed"   : GOSUB Xq
     RETURN

M1d12:
     CALL CALCATTR(GREY,BLUE,ATTR) : Y=2
     X=19: A$="Example:" : GOSUB Xq: Y=7
     X=20: A$="FILE$="+CHR$(34)+"TEST.DAT"+CHR$(34) : GOSUB Xq
     X=21: A$="CALL DELFILE(FILE$,ECODE)" : GOSUB Xq
     X=23: A$="rem  - example only no file was deleted"   : GOSUB Xq
     RETURN
     '---------------------------- menu 2 demos -----------------------------

Menu2Demo:
     SELECT CASE MENPOS
        CASE 1 : GOSUB M2d1
        CASE 2 : GOSUB M2d2
        CASE 3 : GOSUB M2d3
        CASE 4 : GOSUB M2d4
        CASE 5 : GOSUB M2d5
        CASE 6 : GOSUB M2d6
        CASE 7 : GOSUB M2d7
        CASE 8 : GOSUB M2d8
        CASE 9 : GOSUB M2d9
        CASE 10: GOSUB M2d10
        CASE 11: GOSUB M2d11
        CASE 12: GOSUB M2d12
        CASE ELSE
     END SELECT
     RETURN

M2d1:
     GOSUB RestoreScreen2                                        ' restore the basic blank Qb screen
     CALL CALCATTR(WHITE,BLUE,ATTR)
     Y=4 : RESTORE Menu2Note
        FOR X=3 TO 7
           READ A$ : GOSUB Xq
        NEXT X
     CALL CALCATTR(GREY,BLUE,ATTR) : Y=7
     X=9 : A$="ATTRB=7" : GOSUB Xq
     Y=50: A$="' set the file attribute": GOSUB Xq : Y=7
     X=10: A$="SEARCH$="+CHR$(34)+"*.*"+CHR$(34) : GOSUB Xq
     Y=50: A$="' file(s) to search for" : GOSUB Xq
     Y=7 : RESTORE M2d1Data
        FOR X=11 TO 22
           READ A$ : GOSUB Xq
        NEXT X
     CALL CALCATTR(LCYAN,BLUE,ATTR)
     X=24 : A$="Press any key for a listing of this directory"
     Y=40-LEN(A$)\2 : GOSUB Xq                                   ' center it
     GOSUB SaveScreen5
     CALL GETKEY3(MOUSE,CMD,CMD1,LFT,MID,RGT)
     ATTRB=7 : SEARCH$="*.*"
     COLOR 7,0 : CLS
     CALL FINDFIRSTF(SEARCH$,ATTRB,ECODE)
     INDEX=0 : TOT&=0&
        WHILE ECODE=0
           FIL$=SPACE$(12)
           CALL GETNAMEF(FIL$,FLEN)
           F$=LEFT$(FIL$,FLEN)
           K=INSTR(F$,".")-1 : IF K<1 THEN K=FLEN
           A$=LEFT$(F$,K)+SPACE$(8)
           FIL$=LEFT$(A$,8)+RIGHT$(F$,FLEN-K)
           K=INSTR(FIL$,".")
           IF K<>9 THEN FIL$=LEFT$(FIL$,8)+"."
           CALL GETDATEF(MONTH,DAY,YEAR)
           CALL GETTIMEF(HOUR,MIN,SEC)
           CALL GETSIZEFL(FILESIZE&)
           TOT&=TOT&+FILESIZE&
           INDEX=INDEX+1
           Z$=FIL$+SPACE$(12):FIL$=LEFT$(Z$,12)
           FDATE$=RIGHT$("0"+MID$(STR$(MONTH),2),2)+"/"
           FDATE$=FDATE$+RIGHT$("0"+MID$(STR$(DAY),2),2)+"/"
           FDATE$=FDATE$+RIGHT$("0"+MID$(STR$(YEAR),2),2)
           FTIME$=RIGHT$("0"+MID$(STR$(HOUR),2),2)+":"
           FTIME$=FTIME$+RIGHT$("0"+MID$(STR$(MIN),2),2)+":"
           FTIME$=FTIME$+RIGHT$("0"+MID$(STR$(SEC),2),2)
           LOCATE ,1  : PRINT FIL$;
           LOCATE ,15 : PRINT FILESIZE&;
           LOCATE ,25 : PRINT FDATE$;
           LOCATE ,35 : PRINT FTIME$
           CALL FINDNEXTF(ECODE)
        WEND
     DRV$=" " : CALL GETDRV(DRV$)
     CALL DRVSPACEL(DRV$,FREESPACE&)                             ' check the free space
     PRINT : PRINT TOT&;"bytes in";INDEX;"files with";
     PRINT FREESPACE&;"bytes free."
     PRINT : X=25 : Y=1
     CALL CALCATTR(WHITE,RED,ATTR)
     A$=SPACE$(80) : GOSUB Xq : Y=32
     CALL CALCATTR(RED,WHITE,ATTR)
     A$="  Press any key  " : GOSUB Xq
     CALL GETKEY3(MOUSE,CMD,CMD1,LFT,MID,RGT)
     GOSUB RestoreScreen5
     CALL CALCATTR(GREY,BLUE,ATTR)
     X=24 : Y=2 : A$=SPACE$(78) : GOSUB Xq
     RETURN

M2d2:
     GOSUB SetUpExample
     X=18: A$="CALL FINDNEXTF(ECODE)" : GOSUB Xq
     X=19: A$="rem - used with FINDFIRSTF.  If ecode" : GOSUB Xq
     X=20: A$="rem - returns 0, no more matches were" : GOSUB Xq
     X=21: A$="rem - found. " : GOSUB Xq
     X$="FINDNEXTF"
     GOTO NoFileExample
M2d3:
     GOSUB SetUpExample
     X=18: A$="CALL GETNAMEF(FIL$,FLEN)" : GOSUB Xq
     X=19: A$="FIL$=LEFT$(FIL$,FLEN)"    : GOSUB Xq
     X=20: A$="rem - used with FINDFIRSTF." : GOSUB Xq
     X$="GETNAMEF"
     GOTO NoFileExample
M2d4:
     GOSUB SetUpExample
     X=18: A$="CALL GETDATEF(MNTH,DAY,YEAR)":GOSUB Xq
     X=19: A$="rem - used with FINDFIRSTF." : GOSUB Xq
     X$="GETDATEF"
     GOTO NoFileExample
M2d5:
     GOSUB SetUpExample
     X=18: A$="CALL GETTIMEF(HOUR,MIN,SEC)" : GOSUB Xq
     X=19: A$="rem - used with FINDFIRSTF." : GOSUB Xq
     X$="GETTIMEF"
     GOTO NoFileExample
M2d6:
     GOSUB SetUpExample
     X=18: A$="CALL GETSIZEF(SIZELOW,SIZEHIGH)" : GOSUB Xq
     X=19: A$="SIZELOW#=CDBL(SIZELOW)"   : GOSUB Xq
     X=20: A$="IF SIZELOW#<0 THEN SIZELOW#=SIZELOW#+65536": GOSUB Xq
     X=21: A$="FILESIZE#=SIZELOW#+CDBL(SIZEHIGH)*65536" : GOSUB Xq
     X=22: A$="rem - used with FINDFIRSTF." : GOSUB Xq
     X$="GETSIZEF"
     GOTO NoFileExample
M2d7:
     GOSUB SetUpExample
     X=18: A$="CALL GETATTR(ATTR)" : GOSUB Xq
     X=19: A$="rem - used with FINDFIRSTF." : GOSUB Xq
     X$="GETATTRF"
     GOTO NoFileExample

M2d8:
     GOSUB SetUpExample
     X=18: A$="ATTR=&H26                ' set to Hidden, System, Archive" : GOSUB Xq
     X=19: A$="CALL SETFATTR(FIL$,ATTR)" : GOSUB Xq
     RETURN

M2d9:
     GOSUB SetUpExample
     X=18: A$="CALL SETFTD(FIL$,MNTH,DAY,YEAR,HOUR,MINUTE,SECOND)": GOSUB Xq
     X=19: A$="rem - if month=-1 then file was not found" : GOSUB Xq
     RETURN

M2d10:
     GOSUB ExampleWindow
     X=18: A$="FIL$="+CHR$(34)+FIL$+CHR$(34) : GOSUB Xq
     X=19: A$="CALL GETFDATE(FIL$,MNTH,DAY,YEAR)" : GOSUB Xq
     X=20: A$="rem - if mnth=-1 then file was not found" : GOSUB Xq
     CALL GETFDATE(FIL$,MNTH,DAY,YEAR)
     CALL CALCATTR(WHITE,BLUE,ATTR)
     X=22: A$="Month ="+STR$(MNTH) : GOSUB Xq
     X=23: A$="Day   ="+STR$(DAY)  : GOSUB Xq
     X=24: A$="Year  ="+STR$(YEAR) : GOSUB Xq
     RETURN

M2d11:
     GOSUB ExampleWindow
     X=18: A$="FIL$="+CHR$(34)+FIL$+CHR$(34) : GOSUB Xq
     X=19: A$="CALL GETFTIME(FIL$,HOUR,MINUTES,SECONDS)" : GOSUB Xq
     X=20: A$="rem - if hour =-1 then file was not found" : GOSUB Xq
     CALL GETFTIME(FIL$,HOUR,MINUTES,SECONDS)
     CALL CALCATTR(WHITE,BLUE,ATTR)
     X=22: A$="Hours  ="+STR$(HOUR)    : GOSUB Xq
     X=23: A$="Minutes="+STR$(MINUTES) : GOSUB Xq
     X=24: A$="Seconds="+STR$(SECONDS) : GOSUB Xq
     RETURN

M2d12:
     GOSUB ExampleWindow
     X=18: A$="FIL$="+CHR$(34)+FIL$+CHR$(34) : GOSUB Xq
     X=19: A$="CALL GETFATTR(FIL$,ATTR)" : GOSUB Xq
     X=20: A$="rem - refer to the ProBas manual for a " : GOSUB Xq
     X=21: A$="rem - complete explanation of attributes": GOSUB Xq
     CALL GETFATTR(FIL$,ATTRB)
     CALL CALCATTR(WHITE,BLUE,ATTR)
     X=23: A$="Attribute (Decimal) ="+STR$(ATTRB) : GOSUB Xq
     X=24: A$="Attribute (Hex)     = "+HEX$(ATTRB) : GOSUB Xq
     RETURN

     '---------------------------- menu 3 demos -----------------------------

Menu3Demo:
     SELECT CASE MENPOS
        CASE 1 : GOSUB M3d1
        CASE 2 : GOSUB M3d2
        CASE 3 : GOSUB M3d3
        CASE 4 : GOSUB M3d4
        CASE 5 : GOSUB M3d5
        CASE 6 : GOSUB M3d6
        CASE 7 : GOSUB M3d7
        CASE 8 : GOSUB M3d8
        CASE 9 : GOSUB M3d9
        CASE 10: GOSUB M3d10
        CASE 11: GOSUB M3d11
        CASE ELSE
     END SELECT
     RETURN

M3d1:
     GOSUB SetUpExample
     X=18: A$="SOURCE$="+CHR$(34)+"DEMO.EXE"+CHR$(34) : GOSUB Xq
     X=19: A$="DESTIN$="+CHR$(34)+"DEMO.XXX"+CHR$(34) : GOSUB Xq
     X=20: A$="CALL COPYFILE(SOURCE$,DESTIN$,ECODE)" : GOSUB Xq
     CALL CALCATTR(WHITE+16,BLUE,ATTR)
     X=22: A$="Press any key to begin the copy: " : GOSUB Xq
     CALL CALCATTR(WHITE,BLUE,ATTR)
     CALL GETKEY3(MOUSE,CMD,CMD1,LFT,MID,RGT)
     SOURCE$="DEMO.EXE"
     DESTIN$="DEMO.XXX"
     CALL EXIST(DESTIN$,FOUND)
        IF FOUND THEN
           A$="File exists.  Erasing..."+SPACE$(20)
           GOSUB Xq
           CALL DELFILE(DESTIN$,ECODE)
           X=X+1
        END IF
     A$="Copying..."+SPACE$(30) : GOSUB Xq
     CALL COPYFILE(SOURCE$,DESTIN$,ECODE)
     X=X+1 : A$="ECODE ="+STR$(ECODE) : GOSUB Xq
     RETURN

M3d2:
     GOSUB SetUpExample
     X=18: A$="CALL GLOAD(FIL$)" : GOSUB Xq
     X=19: A$="rem - BLOAD for compilers that don't have it." : GOSUB Xq
     RETURN

M3d3:
     GOSUB SetUpExample
     X=18: A$="ATTRB = 0    ' create a normal file" : GOSUB Xq
     X=19: A$="CALL FCREATE(FIL$,ATTRB,HANDLE,ECODE)"  : GOSUB Xq
     X=20: A$="rem - ecode returns non-zero if unable to create": GOSUB Xq
     X=21: A$="rem - returns a file handle that is used": GOSUB Xq
     X=22: A$="rem - much like the BASIC file number."  : GOSUB Xq
     RETURN

M3d4:
     GOSUB SetUpExample
     X=18: A$="READWRITE = 1         ' 0 = read, 1=write, 2=read/write" : GOSUB Xq
     X=19: A$="SHARING = 0           ' don't share with other programs" : GOSUB Xq
     X=20: A$="CALL FOPEN(FIL$,READWRITE,SHARING,HANDLE,ECODE)" : GOSUB Xq
     X=21: A$="rem - ecode returns non-zero if unable to open": GOSUB Xq
     X=22: A$="rem - returns a file handle that is used": GOSUB Xq
     X=23: A$="rem - much like the BASIC file number."  : GOSUB Xq
     RETURN

M3d5:
     GOSUB SetUpExample
     X=18: A$="CALL FCLOSE(HANDLE)" : GOSUB Xq
     X=19: A$="rem - closes a file opened with FOPEN" : GOSUB Xq
     RETURN

M3d6:
     GOSUB SetUpExample
     X=18: A$="rem - open the file..." : GOSUB Xq
     X=19: A$="DOFS = VARPTR(ARRAY(1))     ' the array to read into" : GOSUB Xq
     X=20: A$="BYTES  = 4000               ' the number of bytes to read" : GOSUB Xq
     X=21: A$="CALL FREAD(HANDLE,DOFS,BYTES,BYTESREAD,ECODE)": GOSUB Xq
     X=22: A$="rem - returns ecode non-zero if an error"     : GOSUB Xq
     X=23: A$="rem - returns actual number of BYTESREAD"  : GOSUB Xq
     RETURN

M3d7:
     GOSUB SetUpExample
     X=18: A$="rem - open the file..." : GOSUB Xq
     X=19: A$="DOFS = VARPTR(ARRAY(1))     ' the array to write from"   : GOSUB Xq
     X=20: A$="BYTES  = 4000               ' the number of bytes write" : GOSUB Xq
     X=21: A$="CALL FWRITE(HANDLE,BUFFER,BYTES,BYTESWRITTEN,ECODE)" : GOSUB Xq
     X=22: A$="rem - returns ecode non-zero if an error"     : GOSUB Xq
     X=23: A$="rem - returns actual number of BYTESWRITTEN"  : GOSUB Xq
     RETURN

M3d8:
     GOSUB SetUpExample
     X=18: A$="rem - open the file..." : GOSUB Xq
     X=19: A$="DSEG=VARSEG(ARRAY(1))            ' address of array" : GOSUB Xq
     X=20: A$="DOFS=VARPTR(ARRAY(1))            ' address of array" : GOSUB Xq
     X=21: A$="CALL DFREAD(HANDLE,DSEG,DOFS,BYTES,BYTESREAD,ECODE)" : GOSUB Xq
     X=22: A$="rem - returns ecode non-zero if an error" : GOSUB Xq
     X=23: A$="rem - returns actual number of BYTESREAD" : GOSUB Xq
     RETURN

M3d9:
     GOSUB SetUpExample
     X=18: A$="rem - open the file..." : GOSUB Xq
     X=19: A$="DSEG=VARSEG(ARRAY(1))            ' address of array" : GOSUB Xq
     X=20: A$="DOFS=VARPTR(ARRAY(1))            ' address of array" : GOSUB Xq
     X=21: A$="CALL DFWRITE(HANDLE,DSEG,DOFS,BYTES,BYTESWRITTEN,ECODE)" : GOSUB Xq
     X=22: A$="rem - returns ecode non-zero if an error"       : GOSUB Xq
     X=23: A$="rem - returns actual number of BYTESWRITTEN" : GOSUB Xq
     RETURN

M3d10:
     GOSUB SetUpExample
     X=18: A$="RECSIZE = 128  ' number of bytes per record" : GOSUB Xq
     X=19: A$="RENUMBER= 34   ' record number" : GOSUB Xq
     X=20: A$="CALL FSETREC(HANDLE,RECSIZE,RECNUMBER)" : GOSUB Xq
     RETURN

M3d11:
     GOSUB SetUpExample
     X=18: A$="CALL FSETEND(HANDLE)" : GOSUB Xq
     RETURN

     '---------------------------- demo subroutines -------------------------

ExampleWindow:
     ULR=5 : ULC=44 : LRR=10 : LRC=77 : FRAME=2
     FORE=RED : BACK=GREY : GROW=-1 : SHADOW=-1
     GOSUB WindowManager
     CALL CALCATTR(BLUE,GREY,ATTR): Y=ULC
     X=ULR: A$="Enter the name of a file.   If you" : GOSUB Xq
     X=X+1: A$="can't think of one offhand,  press" : GOSUB Xq
     X=X+1: A$="Enter and we'll use  DEMO2.OVL  on" : GOSUB Xq
     X=X+1: A$="current drive."                     : GOSUB Xq
     X=X+2: COLOR BLUE,WHITE
     LOCATE X,Y,1 : INPUT "File: ",FIL$
     CALL UPCASE(FIL$)
        IF LEN(FIL$)=0 THEN FIL$="DEMO2.OVL"
     Y=Y+6 : A$=FIL$ : GOSUB Xq

SetUpExample:
     CALL CALCATTR(GREY,BLUE,ATTR) : Y=2
     X=17: A$="Example:" : GOSUB Xq: Y=7
     RETURN

NoFileExample:
     ULR=16 : ULC=52 : LRR=20 : LRC=77 : FRAME=2
     FORE=RED : BACK=GREY : SHADOW=-1  : GROW=-1
     GOSUB WindowManager
     CALL CALCATTR(BLUE,WHITE,ATTR) : Y=ULC+1
     X=ULR:A$="The "+X$+" routine"+SPACE$(9-LEN(X$))+" is"   : GOSUB Xq
     X=X+1: A$="used in conjunction with": GOSUB Xq
     X=X+1: A$="the  FINDFIRSTF routine.": GOSUB Xq
     X=X+1: A$="Refer to the  FINDFIRSTF": GOSUB Xq
     X=X+1: A$="demonstration." : GOSUB Xq
     X$=""
     RETURN

NoFileExample3:
     ULR=16 : ULC=52 : LRR=20 : LRC=77 : FRAME=2
     FORE=RED : BACK=GREY : SHADOW=-1  : GROW=-1
     GOSUB WindowManager
     CALL CALCATTR(BLUE,WHITE,ATTR) : Y=ULC+1
     X=ULR: A$="There's no demonstration" : GOSUB Xq
     X=X+1: A$="set up for this routine." : GOSUB Xq
     X$=""
     RETURN

     '----------------------------- data statements -------------------------

InitalScreenText:
     DATA "Recognize this?  It's a  duplicate of the screen used"
     DATA "by QuickBASIC for  the sign-on  screen.  While ProBas"
     DATA "could be  used to write  your own  BASIC compiler, we"
     DATA "just drew this  screen to give you an idea of some of"
     DATA "the capabilities of ProBas. The combination of ProBas"
     DATA "and BASIC gives you  the raw programming power needed"
     DATA "to design anything you can imagine."
     DATA "This part of the demonstration is about the various"
     DATA "ProBas disk and file I/O routines.  ProBas provides"
     DATA "a wide range of over 80 disk and file routines that"
     DATA "can be roughly divided in 3 areas: disk info (DISK)"
     DATA "file info (INFO) and file/data manipulation (FILE)."

BarMenuData:
     DATA "Disk",4,9
     DATA "Info",10,15
     DATA "File",16,21
     DATA "Quit",22,27

Help1Data:
     DATA "The QuickBASIC compiler uses a rather unique mouse/command interface that"
     DATA "uses the 'press-point-release' method with the mouse, and the 'point-and-"
     DATA "press' method with arrow keys.  Personally I prefer the 'point-and-press'"
     DATA "method and that is what we will use for this portion of the demo."
     DATA ""
     DATA "If you are using a mouse, click the left button to select a choice on the"
     DATA "bar menu. Use the mouse to position the highlight and then click the LEFT"
     DATA "mouse button to see a description of the highlighted ProBas routine. Move"
     DATA "the highlight up to the menu bar to exit the pull-down menu."
     DATA ""
     DATA "If you are not using a mouse, use the arrow keys to highlight a choice on"
     DATA "the bar menu and press the Enter key.  Use the arrow keys to  highlight a"
     DATA "choice and press Enter to see a description. Move the highlight up to the"
     DATA "menu bar or press ESC to exit the pull-down menu."

LastRowData:
     DATA 14,14,13,3

Menu1Data:
     DATA DISKSTAT
     DATA DRVSPACE
     DATA EXIST
     DATA SUBEXIST
     DATA GETDRV
     DATA SETDRV
     DATA GETSUB
     DATA SETSUB
     DATA DELSUB
     DATA MAKESUB
     DATA RENAME
     DATA DELFILE

Menu2Data:
     DATA FINDFIRSTF
     DATA FINDNEXTF
     DATA GETNAMEF
     DATA GETDATEF
     DATA GETTIMEF
     DATA GETSIZEF
     DATA GETATTRF
     DATA SETFATTR
     DATA SETFTD
     DATA GETFDATE
     DATA GETFTIME
     DATA GETFATTR

Menu3Data:
     DATA COPYFILE
     DATA GLOAD
     DATA FCREATE
     DATA FOPEN
     DATA FCLOSE
     DATA FREAD
     DATA FWRITE
     DATA DFREAD
     DATA DFWRITE
     DATA FSETREC
     DATA FSETEND

Menu1Descriptions:
     DATA "Returns information  about the|disk including total clusters,|free clusters, etc."
     DATA "Returns  the  amount  of  free|disk space for a given drive."
     DATA "Checks if the  specified  file|exists.   Better than  BASIC's|error trapping and can be used|in subprograms."
     DATA "Checks if  specified directory|exists.  Faster than using the|BASIC CHDIR and event trapping|with far less overhead."
     DATA "Returns  the currently  logged|drive using the letters A-Z."
     DATA "Changes to  new drive. Returns|error code  for invalid drive.|Works  without  BASIC's  error|trapping and in subprograms."
     DATA "Returns the current directory."
     DATA "Changes to a new subdirectory.|Returns  error  code if unable|to change the subdirectory."
     DATA "Deletes a  directory.  Returns|an error code if unsuccessful.|Better than BASIC's and can be|used in subprograms."
     DATA "Makes a directory.  Returns an|error code if not  successful.|Can be used in subprograms."
     DATA "Renames a  disk file.  Returns|an error code  and can be used|in subprograms."
     DATA "Deletes a  disk file.  Returns|an error code  and can be used|in subprograms."

Menu2Descriptions:
     DATA "Finds the first file  matching|the filespec (wildcards ok) in|the specified drive\path.  Use|FINDNEXTF  to find  additional|matches.   GETNAMEF, GETATTRF,|GETDATEF, GETTIMEF, & GETSIZEF|work with FINDFIRSTF/FINDNEXTF"
     DATA "Continues the search initiated|by FINDFIRSTF.Using FINDFIRSTF|and FINDNEXTF you can find the|files that match a  given spec|for directory programs, etc."
     DATA "Returns  the  name of the file|found by FINDFIRSTF/FINDNEXTF."
     DATA "Returns the date stamp for the|file found  by  FINDFIRSTF  or|FINDNEXTF."
     DATA "Returns the time stamp for the|file found  by  FINDFIRSTF  or|FINDNEXTF."
     DATA "Returns  the size in bytes  of|the file  found by  FINDFIRSTF|or FINDNEXTF"
     DATA "Returns  the  file  attributes|(READ, WRITE, HIDDEN, etc.) of|the file found with FINDFIRSTF|or FINDNEXTF."
     DATA "Sets the file attribute of the|specified file."
     DATA "Sets the file time/date  stamp|of the specified file."
     DATA "Returns the  date stamp of the|specified file."
     DATA "Returns the  time stamp of the|specified file."
     DATA "Returns  the  file  attributes|for the specified file."

Menu2Note:
     DATA "The routines FINDFIRSTF and FINDNEXTF work in conjunction to allow you to"
     DATA "search a given directory for files that match a specified search criteria"
     DATA "(wildcards * and ? are allowed). The routines GETNAMEF,GETDATEF,GETTIMEF,"
     DATA "GETSIZEFL, and GETATTRF work with FINDFIRSTF and FINDNEXTF to return the"
     DATA "name, date, time, size, and file attributes for each file:"

M2d1Data:
     DATA "CALL FINDFIRSTF(SEARCH$,ATTRB,ECODE)       ' find the first file"
     DATA "   WHILE ECODE=0                           ' loop til all are found"
     DATA "      FIL$=SPACE$(12)                      ' pad the string"
     DATA "      CALL GETNAMEF(FIL$,FLEN)             ' get the name"
     DATA "      FIL$=LEFT$(FIL$,FLEN)                ' set the file name
     DATA "      CALL GETDATEF(MNTH,DAY,YEAR)         ' get the date"
     DATA "      CALL GETTIMEF(HOUR,MIN,SECOND)       ' get the time"
     DATA "      CALL GETSIZEFL(FILESIZE&)            ' get the size"
     DATA "      CALL FINDNEXTF(SEARCH$,ATTRB,ECODE)  ' find next match until..."
     DATA "   WEND                                    ' ... all matches are found"

Menu3Descriptions:
     DATA "A low-level assembly  language|routine  that will copy a file|faster than using the DOS copy|command via SHELL.  Returns an|error code if unsuccessful."
     DATA "A BLOAD routine for BASCOM and|QuickBASIC 1.01 compilers."
     DATA "Creates a file.  Used with the|FOPEN,  FCLOSE, FREAD, FWRITE,|DFREAD, and DFWRITE  routines.|Returns the file handle."
     DATA "Opens a file for I/O.  Returns|an error code if unsuccessful.|Can  be  used without  BASIC's|error trapping for use in sub-|programs.  Allows networking."
     DATA "Closes a file opened with  the|FOPEN routine."
     DATA "Reads a  file opened with  the|FOPEN routine. You specify the|number of  bytes to  read  and|the record number.  Returns an|error code if unsuccessful."
     DATA "Writes to a file  opened  with|FOPEN."
     DATA "Reads a file opened with FOPEN|into an array. Both STATIC and|DYNAMIC arrays are supported."
     DATA "Writes the  contents of either|a STATIC or DYNAMIC array to a|file opened with FOPEN."
     DATA "Sets the record pointer.  Used|by the FREAD, FWRITE, DFREAD &|DFWRITE routines."
     DATA "Sets the record pointer to the|end of the file for  appending|with FWRITE or DFWRITE."

     '--------------------------- misc gosub routines -----------------------

SetBarMouse:
     A=BAR.ROW : B=LMPOS(1) : C=BAR.ROW : D=LMPOS(MAXMENU)       ' use the bar row only
     CALL SETMOUSERANGE(A,B,C,D)                                 ' set the mouse range for the bar row only
     CALL SETMOUSELOC(A,B)                                       ' set the mouse location
     MROW=A : MCOL=B                                             ' set the mouse location variable
     SROW=A : SCOL=B                                             ' set the save mouse location variable
     RETURN

SetMenuMouse:
        IF MENU=0 THEN RETURN
     CALL SETMOUSERANGE(BAR.ROW,ULC(MENU),LRR(MENU),LRC(MENU))   ' set the range to that of the pull-down window
     CALL SETMOUSELOC(ULR(MENU),ULC(MENU))                       ' position the mouse at the first choice
     MROW=ULR(MENU) : MCOL=ULC(MENU)                             ' set the mouse location variable
     SROW=MROW : SCOL=MCOL                                       ' set the save mouse location variable
     MENPOS=ULR(MENU) : MENPOSAVE=MENPOS                         ' save the hilight position
     RETURN

DWindowManager:
     CALL DWindowManager(DSEG,DOFS,ULR,ULC,LRR,LRC,FRAME,FORE,_
                         BACK,GROW,SHADOW,LABEL,LABEL$)
     RETURN

WindowManager:
     CALL WindowManager(ULR,ULC,LRR,LRC,FRAME,FORE,BACK,_
                        GROW,SHADOW,LABEL,LABEL$,PAGE,SCRMODE)
     RETURN

ReColorHighlight:
     CALL CALCATTR(RED,GREY,HIATTR)                              ' the color for the bar highlight
        IF MENU THEN
           CALL CALCATTR(WHITE,BLACK,HMATTR)
        ELSE
           CALL CALCATTR(BLACK,CYAN,HMATTR)
        END IF
     CALL RECOLORAREA(OROW,OLPOS,OROW,ORPOS,HMATTR,PAGE,SCRMODE) ' reset the previous highlighted choice back to normal
     CALL RECOLORAREA(NROW,NLPOS,NROW,NRPOS,HIATTR,PAGE,SCRMODE) ' set the new highlighted choice
     HIGHLIGHT=NROW
     RETURN

     '------------------- clean up and return to main menu ------------------

Quit:
        IF MOUSE THEN CALL MMCURSOROFF
     GOSUB RestoreScreen                                         ' restore the main menu screen
     RESTART=-1                                                  ' set restart flag
     CHAIN "DEMO"                                                ' do the chain

     '------------------------ standard sub-routines ------------------------

SaveScreen:
     XSEG=VARSEG(SCR1(1))
     XOFS=VARPTR(SCR1(1))
     CALL DSCRSAVE(XSEG,XOFS,PAGE,SCRMODE)
     RETURN

RestoreScreen:
     XSEG=VARSEG(SCR1(1))
     XOFS=VARPTR(SCR1(1))
     CALL DSCRREST(XSEG,XOFS,PAGE,SCRMODE)
     RETURN

SaveScreen2:
     XSEG=VARSEG(SCR2(1))
     XOFS=VARPTR(SCR2(1))
     CALL DSCRSAVE(XSEG,XOFS,PAGE,SCRMODE)
     RETURN

RestoreScreen2:
     XSEG=VARSEG(SCR2(1))
     XOFS=VARPTR(SCR2(1))
     CALL DSCRREST(XSEG,XOFS,PAGE,SCRMODE)
     RETURN

SaveScreen3:
     XSEG=VARSEG(SCR3(1))
     XOFS=VARPTR(SCR3(1))
     CALL DSCRSAVE(XSEG,XOFS,PAGE,SCRMODE)
     RETURN

RestoreScreen3:
     XSEG=VARSEG(SCR3(1))
     XOFS=VARPTR(SCR3(1))
     CALL DSCRREST(XSEG,XOFS,PAGE,SCRMODE)
     RETURN

SaveScreen4:
     XSEG=VARSEG(SCR4(1))
     XOFS=VARPTR(SCR4(1))
     CALL DSCRSAVE(XSEG,XOFS,PAGE,SCRMODE)
     RETURN

RestoreScreen4:
     XSEG=VARSEG(SCR4(1))
     XOFS=VARPTR(SCR4(1))
     CALL DSCRREST(XSEG,XOFS,PAGE,SCRMODE)
     RETURN

SaveScreen5:
     XSEG=VARSEG(SCR5(1))
     XOFS=VARPTR(SCR5(1))
     CALL DSCRSAVE(XSEG,XOFS,PAGE,SCRMODE)
     RETURN

RestoreScreen5:
     XSEG=VARSEG(SCR5(1))
     XOFS=VARPTR(SCR5(1))
     CALL DSCRREST(XSEG,XOFS,PAGE,SCRMODE)
     RETURN

Xq:  CALL XQPRINT(A$,X,Y,ATTR,PAGE,SCRMODE)
     RETURN

DXq: CALL DXQPRINT(DSEG,DOFS,A$,X,Y,ATTR)
     RETURN
