     DEFINT A-Z
     rem $STATIC:
     DIM SCR1(2000),SCR2(2000),SCR3(2000),SCR4(2000)

     rem $INCLUDE: 'COMDEF.BAS'

     DEF SEG=0
     PAGE=0
     LOCATE 23,1,0                                               ' locate and turn off the cursor
     CALL CALCATTR(MAG,BLACK,TIMATTR)                            ' set the color for the on-screen clock

     '---------------------------- memory management ------------------------

MemoryManagement:

     ' This section does almost the exact same thing
     ' as DEMO1.EXE.  Since there is nothing really
     ' new in this area of the code, we'll skip sans the
     ' narrative, in do things in a nice tight module.

     GOSUB SaveScreen                                            ' save the main screen for return
     GOSUB SaveScreen2                                           ' copy active screen to virtual
     GOSUB SaveScreen3                                           ' copy to scratch scr for drawing menus
     DSEG=VARSEG(SCR2(1))
     DOFS=VARPTR(SCR2(1))
     TSEG=VARSEG(SCR3(1))
     TOFS=VARPTR(SCR3(1))

     rem $DYNAMIC:
     REDIM MENU$(4),LMPOS(4),RMPOS(4),LASTROW(4),ELM(4)
     REDIM DSEG(4),DOFS(4),ULR(4),ULC(4),LRR(4),LRC(4)
     RESTORE BarMenuData                                         ' restore the data
        FOR I=1 TO 4                                             ' read for 4 choices
           READ MENU$(I)                                         ' menu choice text
           READ LMPOS(I),RMPOS(I)                                ' left col and right col
        NEXT I                                                   ' loop
     MAXMENU=4                                                   ' number of menu choices on bar
     CALL CALCATTR(LCYAN,MAG,ATTR)                               ' the color of the bar
     X=2 : Y=2 : A$=SPACE$(78) : GOSUB DXq                       ' clear the bar row, but not the frame...
     BAR.ROW=2                                                   ' remember the row the bar menu is on
        FOR I=1 TO 4                                             ' loop thru the choices
           Y=LMPOS(I)+1                                          ' set the location
           A$=MENU$(I) : GOSUB DXq                               ' read and write the choice
        NEXT I                                                   ' keep on truckin'
     RESTORE LastRowData
        FOR I=1 TO 3                                             ' read thru the number of menu choices
           READ LASTROW(I)                                       ' lastrow() is the physical bottom row...
        NEXT I                                                   ' ... of the particular menu.
     RESTORE Menu1Data                                           ' restore the menu choices starting with menu 1
        FOR I=1 TO 3                                             ' loop thru
           LONGEST=0                                             ' how wide to make the window
           FOR J=4 TO LASTROW(I)                                 ' nested loop to read the choices for this menu,
              READ A$ : L=LEN(A$)                                ' find the widest meu choice and get the len
              IF L>LONGEST THEN LONGEST=L                        ' find the longest text entry in the window
           NEXT J                                                ' the window
           ULR(I)=4 : ULC(I)=LMPOS(I) : LRR(I)=LASTROW(I)        ' compute the rest of the window positions
           LRC(I)=ULC(I)+LONGEST+1                               ' and set the right column so all choices fit in
           A=1 : B=ULC(I)-1 : C=LRR(I)+1 : D=LRC(I)+1            ' put into variables since we can't do math within a call
           CALL CALCSIZE(A,B,C,D,ELM(I))                         ' calculate the size for the virtual screen array
        NEXT I                                                   ' set up the virtual screen arrays below
     REDIM MENU1(ELM(1))
     DSEG(1)=VARSEG(MENU1(1)) : DOFS(1)=VARPTR(MENU1(1))
     REDIM MENU2(ELM(2))
     DSEG(2)=VARSEG(MENU2(1)) : DOFS(2)=VARPTR(MENU2(1))
     REDIM MENU3(ELM(3))
     DSEG(3)=VARSEG(MENU3(1)) : DOFS(3)=VARPTR(MENU3(1))
     RESTORE Menu1Data                                           ' restore the menu choice data again
        FOR I=1 TO 3                                             ' loop thru each of the menus
           CALL VPUTSCREEN(TSEG,TOFS,1,1,25,80,DSEG,DOFS)        ' reset the scratch screen so that it has the main screen
           FORE=LRED : BACK=BLUE : FRAME=4                       ' set and draw the menu window
           LABEL=YELLOW : LABEL$=MENU$(I)                        ' set the label
           CALL DWindowManager(TSEG,TOFS,ULR(I),ULC(I),LRR(I),LRC(I),_
                               FRAME,FORE,BACK,GROW,SHADOW,LABEL,LABEL$)
           CALL CALCATTR(RED,GREY,ATTR)                          ' colors for the bar menu highlight
           X=BAR.ROW : Y=LMPOS(I)                                ' set the x/y pos of the bar menu choice
           A$=" "+MENU$(I)+" "                                   ' allow a space on each side so it's highlighted
           CALL DXQPRINT(TSEG,TOFS,A$,X,Y,ATTR)                  ' highlight the bar menu choice
           Y=ULC(I)+1                                            ' set the y pos for the menu choices
           CALL CALCATTR(LCYAN,BLUE,ATTR)                        ' set the color for the menu choices
              FOR X=4 TO LASTROW(I)                              ' loop thru this menu's rows
                  READ A$ : CALL DXQPRINT(TSEG,TOFS,A$,X,Y,ATTR) ' reading and writing the choice and
              NEXT X                                             ' til all choices are written
           A=1 : B=ULC(I)-1 : C=LRR(I)+1 : D=LRC(I)+1            ' get the virtual screens position from the arrays
           CALL VGETSCREEN(TSEG,TOFS,A,B,C,D,DSEG(I),DOFS(I))    ' ship the menu from scratch to its own virtual screen
        NEXT I                                                   ' move on to the next menu
     GOSUB RestoreScreen2                                        ' display the screen with the bar menu
     OROW=BAR.ROW : NROW=OROW                                    ' the row the menu bar is on
     OLPOS=LMPOS(1) : ORPOS=RMPOS(1)                             ' the position of the old highlight
     NLPOS=LMPOS(1) : NRPOS=RMPOS(1)                             ' the position of the new highlight
     GOSUB ReColorHighlight                                      ' set the highlight
     BARPOS=1 : BARPOSAVE=1                                      ' save the pos of highlight
     MENU=0                                                      ' no pull-down menu yet selected
     GOSUB SaveScreen2

     CALL CALCATTR(GREY,BLACK,ATTR) : Y=2
     X=23:A$="Use the arrow keys or the mouse to position the highlight. Press the Enter key" : GOSUB Xq
     X=24:A$="key or click the Left button to select.  To exit a menu, press Esc,  click the" : GOSUB Xq
     X=25:A$="right button, or move the highlight up to the bar." : GOSUB Xq
     HELP=-1

        IF MOUSE THEN GOSUB SetBarMouse                          ' set the mouse for the bar only
        IF MOUSE THEN CALL SETMOUSELOC(BAR.ROW,LMPOS(1))         ' position at first bar menu choice

     '------------------------------ main command ---------------------------

MainCom:                                                         ' the main keyboard/mouse input routine
     CLOCKOFF=0                                                  ' set the clock display back on in case it was turned off
     CLICK=0                                                     ' clear the flag
        WHILE NOT CLICK                                          ' wait for a keypress or a mouse click
           CALL CHECKKEY(MOUSE,CMD,CMD1,LFT,RGT)                 ' check for keypress or mouse click
           IF MOUSE THEN GOSUB MoveBarMouse                      ' check to see if the mouse has been moved
           GOSUB Clock                                           ' update the time
           IF CMD<>0 OR CMD1<>0 OR LFT<>0 OR RGT<>0 THEN CLICK=-1' if a keypress or mouse click then exit the while/wend loop
        WEND                                                     ' keep on truckin'
        IF HELP THEN GOSUB ClearCommand                          ' clear the help text
        IF CMD1=80 AND MENU<>0 THEN GOSUB MoveHiDown:GOTO MainCom' down arrow  - move highlight down in menu
        IF CMD1=72 AND MENU<>0 THEN GOSUB MoveHiUp:GOTO MainCom  ' up arrow    - move highlight up in menu
        IF CMD1=77 THEN GOSUB MoveHiRight : GOTO MainCom         ' right arrow - move right one choice on bar
        IF CMD1=75 THEN GOSUB MoveHiLeft  : GOTO MainCom         ' left arrow  - move left one choice on bar
        IF LFT<>0 OR CMD=13 THEN GOTO CheckChoice                ' they pressed Enter or clicked left button
        IF RGT<>0 AND MENU<>0 THEN GOSUB ResetBar : GOTO MainCom ' click right button to exit pull-down
        IF CMD=27 AND MENU<>0 THEN GOSUB ResetBar:GOTO MainCom   ' they exited the pull-down menu so reset the bar menu
        IF CMD=27 THEN GOTO Quit                                 ' if ESC then end
     GOTO MainCom                                                ' keep checking for input

MoveBarMouse:
     CALL GETMOUSELOC(MROW,MCOL)                                 ' get the current mouse location
        IF MROW=SROW AND MCOL=SCOL THEN RETURN                   ' the mouse has not moved since we last checked
        IF MENU<>0 THEN GOTO MenuMouse                           ' we have a menu active so we're not on the bar
        IF MROW<>BAR.ROW THEN GOTO MenuMouse                     ' remember that NOT MENU only works if MENU=-1
BarM2:
        IF MCOL>LMPOS(BARPOS) THEN GOSUB MoveHiRight : RETURN    ' move right one bar choice
        IF MCOL<RMPOS(BARPOS) THEN GOSUB MoveHiLeft  : RETURN    ' move left  one bar choice
     RETURN

MenuMouse:
        IF MROW<ULR(MENU) THEN GOSUB ResetBar : RETURN           ' mouse moved out of the pull-down so back to bar menu
        IF MROW>MENPOS+3 THEN GOSUB MoveHiDown: RETURN           ' mouse moved down 1 row or more
        IF MROW<MENPOS+3 THEN GOSUB MoveHiUp  : RETURN           ' mouse moved up 1 row or more
     RETURN

ResetBar:
     A=1 : B=ULC(MENU)-1 : C=LRR(MENU)+1 : D=LRC(MENU)+1         ' this is the area that the pull-down overwrote
     DSEG=VARSEG(SCR2(1))
     DOFS=VARPTR(SCR2(1))
     CALL DPUTSCREEN(DSEG,DOFS,A,B,C,D,PAGE,SCRMODE)             ' restore just the area that was overwritten
        IF MOUSE THEN GOSUB RB2                                  ' set the mouse range for the menu bar
     MENPOS=0 : MENPOSAVE=0                                      ' clear the pull-down menu locations
     MENU=0                                                      ' set the menu flag to no menu
     RETURN
RB2: GOSUB SetBarMouse                                           ' set the mouse range for the bar
     CALL SETMOUSELOC(BAR.ROW,LMPOS(BARPOS))                     ' set the mouse location
     MROW=BAR.ROW : MCOL=LMPOS(BARPOS)                           ' reset the mouse pointers...
     SROW=MROW    : SCOL=MCOL                                    ' old and new
     RETURN

DisplayMenu:
     MENU=BARPOS
        IF MENU=4 THEN GOTO Quit                                 ' the Quit choice has no menu!
     MSEG=DSEG(MENU)                                             ' pull the data seg...
     MOFS=DOFS(MENU)                                             ' and offset from storage array
     A=1 : B=ULC(MENU)-1                                         ' set the size of the virtual screen
     C=LRR(MENU)+1 : D=LRC(MENU)+1                               ' menu to display, allowing for the window frame
     DSEG=VARSEG(SCR2(1))
     DOFS=VARPTR(SCR2(1))
     CALL DGETSCREEN(DSEG,DOFS,A,B,C,D,PAGE,SCRMODE)                ' take a snapshot the area that will be overwritten
     CALL DPUTSCREEN(MSEG,MOFS,A,B,C,D,PAGE,SCRMODE)             ' ship menu from virtual to active screen
     OROW=ULR(MENU)  : NROW=OROW                                 ' set the row for the highlight
     OLPOS=ULC(MENU) : ORPOS=LRC(MENU)                           ' set the save columns
     NLPOS=ULC(MENU) : NRPOS=LRC(MENU)                           ' set the left/right sides of the highlight
        IF MOUSE THEN GOSUB SetMenuMouse                         ' set the mouse range and loc for pull-down
     GOSUB ReColorHighlight                                      ' highlight first choice in pull-down
     MENPOS=1 : MENPOSAVE=1                                      ' set the highlight pos for the vertical menu to 1
     RETURN

MoveHiRight:
     CALL CALCATTR(LCYAN,MAG,HMATTR)                             ' set the colors
        IF MONO THEN CALL CALCATTR(GREY,BLACK,HMATTR)            ' default doesn't look good in mono so change them
        IF BARPOS=5 THEN GOTO MainCom                            ' if we're at the end, return (or we could wrap by setting it to 1)
     BARPOS=BARPOS+1                                             ' increment the pointer
     OROW=BAR.ROW : NROW=OROW                                    ' set the row
     OLPOS=LMPOS(BARPOSAVE): ORPOS=RMPOS(BARPOSAVE)              ' set the old left/right columns
     NLPOS=LMPOS(BARPOS)   : NRPOS=RMPOS(BARPOS)                 ' set the new left/right columns
     GOSUB ReColorHighlight                                      ' move the highlight
     BARPOSAVE=BARPOS                                            ' update the position pointer
        IF MOUSE THEN                                            ' feed the mouse the new position info
           CALL SETMOUSELOC(BAR.ROW,LMPOS(BARPOS))
           MROW=BAR.ROW : MCOL=LMPOS(BARPOS)
           SROW=MROW : SCOL=MCOL
        END IF
     RETURN                                                      ' done

MoveHiLeft:
     CALL CALCATTR(LCYAN,MAG,HMATTR)                             ' set the color
        IF MONO THEN CALL CALCATTR(GREY,BLACK,HMATTR)            ' default doesn't look good in mono so change them
        IF BARPOS=1 THEN GOTO MainCom                            ' if full left then we can't go any farther, return
     BARPOS=BARPOS-1                                             ' decrement the pointer
     OROW=BAR.ROW : NROW=OROW                                    ' set the row
     OLPOS=LMPOS(BARPOSAVE): ORPOS=RMPOS(BARPOSAVE)              ' set the old left/right columns
     NLPOS=LMPOS(BARPOS)   : NRPOS=RMPOS(BARPOS)                 ' set the new left/right columns
     GOSUB ReColorHighlight                                      ' move the highlight
     BARPOSAVE=BARPOS                                            ' update the position pointer
        IF MOUSE THEN                                            ' feed the mouse the new position info
           CALL SETMOUSELOC(BAR.ROW,LMPOS(BARPOS))
           MROW=BAR.ROW: MCOL=LMPOS(BARPOS)
           SROW=MROW: SCOL=MCOL
        END IF
     RETURN                                                      ' done

MoveHiDown:
        IF MENPOS+3 = LASTROW(MENU) THEN RETURN                  ' we are at the bottom menu choice
     CALL CALCATTR(LCYAN,BLUE,HMATTR)                            ' set the menu text color
     MENPOS=MENPOS+1                                             ' increment the pointer
     OROW=MENPOSAVE+3                                            ' set the old position
     NROW=MENPOS+3                                               ' set the new position
     OLPOS=ULC(MENU) : ORPOS=LRC(MENU)                           ' set the left and right columns
     NLPOS=ULC(MENU) : NRPOS=LRC(MENU)                           ' old and new...
     GOSUB ReColorHighlight                                      ' move the highlight
     MENPOSAVE=MENPOS                                            ' reset the pointer to the current position
        IF MOUSE THEN                                            ' if a mouse then feed it the new position
           CALL SETMOUSELOC(NROW,ULC(MENU))
           MROW=BROW: MCOL=ULC(MENU)
           SROW=MROW: SCOL=MCOL
        END IF
     RETURN                                                      ' done

MoveHiUp:
        IF MENPOS=1 THEN GOTO ResetBar                           ' close the pull-down and rest the menu bar
     CALL CALCATTR(LCYAN,BLUE,HMATTR)                            ' set the color
     MENPOS=MENPOS-1                                             ' decrement the pointer
     OROW=MENPOSAVE+3                                            ' set the old position
     NROW=MENPOS+3                                               ' set the new position
     OLPOS=ULC(MENU) : ORPOS=LRC(MENU)                           ' set the old left and right columns
     NLPOS=ULC(MENU) : NRPOS=LRC(MENU)                           ' set the new left and right columns
     GOSUB ReColorHighlight                                      ' move the highlight
     MENPOSAVE=MENPOS                                            ' reset the pointer
        IF MOUSE THEN                                            ' feed that hungry mouse
           CALL SETMOUSELOC(NROW,ULC(MENU))
           MROW=BROW: MCOL=ULC(MENU)
           SROW=MROW: SCOL=MCOL
        END IF
     RETURN                                                      ' done

CheckChoice:
        IF BARPOS=4 THEN GOTO Quit                               ' the Quit choice
        IF MENU=0 THEN GOSUB DisplayMenu : GOTO MainCom          ' they selected a pull-down menu

     ON MENU GOTO Menu1,Menu2,Menu3

     '--------------------------- pull-down menu 1 --------------------------

Menu1:
     GOSUB SaveScreen3                                           ' take a snapshot of the screen
        IF MENPOS=1 THEN GOTO Menu1.1
     RESTORE Menu1Descriptions                                   ' restore the menu choice descriptions
     GOSUB GetAndDisplayText                                     ' the label says it all...
     GOTO MainCom                                                ' go back for another command

Menu1.1:
     PSEG=VARSEG(SCR4(1))
     POFS=VARPTR(SCR4(1))
     FIL$="SCRTEXT.DAT"                                          ' file name
     FACCESS=0                                                   ' open for read. 1= write, 2=read/write
     FMODE=0                                                     ' no locking or network
     CALL FOPEN(FIL$,FACCESS,FMODE,HANDLE,ECODE)                 ' open the file and return the file handle
        IF ECODE THEN GOTO FileNoGood                            ' we had an error!
     RECSIZE=4000                                                ' 4000 byte records
     RECNUMBER=6                                                 ' specify record 2
     BYTES=4000                                                  ' 2000 elements = 4000 bytes
     CALL FSETREC(HANDLE,RECSIZE,RECNUMBER)                      ' set the record pointer
     CALL DFREAD(HANDLE,PSEG,POFS,BYTES,BYTESREAD,ECODE)         ' read the second record
        IF ECODE THEN GOTO FileNoGood                            ' we had an error!
        IF BYTESREAD<>BYTES THEN GOTO FileNoGood                 ' we had an error!
     CLOCKOFF=-1                                                 ' flag to turn the clock display off
     GOSUB RestoreScreen4                                        ' display the picture
     GOSUB KeyClick                                              ' wait for a keypress or mouse click
     GOSUB RestoreScreen3                                        ' restore the menu screen
     BYTES=0:BYTEREAD=0:HANDLE=0:PSEG=0:POFS=0:FIL$=""           ' clear the garbage variables
     RECSIZE=0:RECNUMBER=0
     GOTO MainCom                                                ' done!

FileNoGood:
     CLOCKOFF=0                                                  ' reset the clock display to on
     GOSUB ClearCommand                                          ' clear the command line
     PRINT "Error!  Unable to open the data file.  Press any key:";
     GOSUB KeyClick                                              ' wait for a keypress or mouse click
     GOSUB RestoreScreen3                                        ' restore the menu screen
     BYTES=0:BYTEREAD=0:HANDLE=0:PSEG=0:POFS=0:FIL$=""           ' clear the garbage variables
     RECSIZE=0:RECNUMBER=0
     GOTO MainCom                                                ' done!

     '--------------------------- pull-down menu 2 --------------------------

Menu2:
     GOSUB SaveScreen3                                           ' take a snapshot of the screen
        IF MENPOS=1 THEN GOTO Menu2.1
     RESTORE Menu2Descriptions                                   ' restore the menu choice descriptions
     GOSUB GetAndDisplayText                                     ' the label says it all...
     GOTO MainCom                                                ' go back for another command

Menu2.1:
     PSEG=VARSEG(SCR4(1))
     POFS=VARPTR(SCR4(1))
     FIL$="SCRTEXT.DAT"
     FACCESS=0                                                   ' open for read. 1= write, 2=read/write
     FMODE=0                                                     ' no locking or network
     CALL FOPEN(FIL$,FACCESS,FMODE,HANDLE,ECODE)                 ' open the file and return the file handle
        IF ECODE THEN GOTO FileNoGood                            ' we had an error!
     RECSIZE=4000                                                ' 4000 byte records
     RECNUMBER=7                                                 ' specify record 2
     BYTES=4000                                                  ' 2000 elements = 4000 bytes
     CALL FSETREC(HANDLE,RECSIZE,RECNUMBER)                      ' set the record pointer
     CALL DFREAD(HANDLE,PSEG,POFS,BYTES,BYTESREAD,ECODE)         ' read the second record
        IF ECODE THEN GOTO FileNoGood                            ' we had an error!
        IF BYTESREAD<>BYTES THEN GOTO FileNoGood                 ' we had an error!
     CLOCKOFF=-1                                                 ' flag to turn the clock display off
     GOSUB RestoreScreen4                                        ' display the picture
     GOSUB KeyClick                                              ' wait for a keypress or mouse click
     GOSUB RestoreScreen3                                        ' restore the menu screen
     BYTES=0:BYTEREAD=0:HANDLE=0:PSEG=0:POFS=0:FIL$=""           ' clear the garbage variables
     RECSIZE=0:RECNUMBER=0
     GOTO MainCom                                                ' done!

     '--------------------------- pull-down menu 3 --------------------------

Menu3:
     GOSUB SaveScreen3                                           ' take a snapshot of the screen
        IF MENPOS=1 THEN GOTO Menu3.1
     RESTORE Menu3Descriptions                                   ' restore the menu choice descriptions
     GOSUB GetAndDisplayText                                     ' the label says it all...
     GOTO MainCom                                                ' go back for another command

Menu3.1:
     PSEG=VARSEG(SCR4(1))
     POFS=VARPTR(SCR4(1))
     FIL$="SCRTEXT.DAT"
     FACCESS=0                                                   ' open for read. 1= write, 2=read/write
     FMODE=0                                                     ' no locking or network
     CALL FOPEN(FIL$,FACCESS,FMODE,HANDLE,ECODE)                 ' open the file and return the file handle
        IF ECODE THEN GOTO FileNoGood                            ' we had an error!
     RECSIZE=4000                                                ' 4000 byte records
     RECNUMBER=8                                                 ' specify record 2
     BYTES=4000                                                  ' 2000 elements = 4000 bytes
     CALL FSETREC(HANDLE,RECSIZE,RECNUMBER)                      ' set the record pointer
     CALL DFREAD(HANDLE,PSEG,POFS,BYTES,BYTESREAD,ECODE)         ' read the second record
        IF ECODE THEN GOTO FileNoGood                            ' we had an error!
        IF BYTESREAD<>BYTES THEN GOTO FileNoGood                 ' we had an error!
     CLOCKOFF=-1                                                 ' flag to turn the clock display off
     GOSUB RestoreScreen4                                        ' display the picture
     GOSUB KeyClick                                              ' wait for a keypress or mouse click
     GOSUB RestoreScreen3                                        ' restore the menu screen
     BYTES=0:BYTEREAD=0:HANDLE=0:PSEG=0:POFS=0:FIL$=""           ' clear the garbage variables
     RECSIZE=0:RECNUMBER=0
     GOTO MainCom                                                ' done!

     '---------------- get and display menu choice descriptions -------------

GetAndDisplayText:
     MORE=0 : HI=0
        FOR J=1 TO MENPOS                                        ' read thru the data statements...
           READ A$,A1$                                           ' til we reach the one we want...
        NEXT J                                                   ' now we have it!
        IF LEN(A$)=0 OR LEN(A1$)=0 THEN GOTO Gad                 ' error - nothing there!
     REDIM A$(20)                                                ' set up an array for text descriptions
     SLEN=1 : INDEX=0                                            ' set/clear pointers
     DELIM$="|"                                                  ' specify the delimiter
        WHILE SLEN>0                                             ' loop
           INDEX=INDEX+1                                         ' increment the pointer
           CALL EXTRACT(A$,DELIM$,INDEX,ST,SLEN)                 ' do the call
           A$(INDEX)=MID$(A$,ST,SLEN)                            ' load the delimited string into array
        WEND                                                     ' loop til done
     COUNT=INDEX-1 : HI=COUNT+1                                  ' save count and where to start highlight color
     SLEN=1 : INDEX=0                                            ' clear the flags and pointers
        WHILE SLEN>0                                             ' loop
           INDEX=INDEX+1                                         ' increment the pointer
           COUNT=COUNT+1                                         ' increment the total index pointer
           CALL EXTRACT(A1$,DELIM$,INDEX,ST,SLEN)                ' do the call
           A$(COUNT)=MID$(A1$,ST,SLEN)                           ' load the delimited string into array
        WEND                                                     ' loop til done
     INDEX=COUNT
     SS=SCRMODE : SCRMODE=0                                      ' save the mode and force it to slow for a growing window
     UR=15 : UC=4 : LR=UR+INDEX-2 : LC=76                        ' use different variables so we don't mess up the menu vars!
        IF LR>24 THEN UR=25-INDEX : LR=UR+INDEX-2 : X=UR         ' make sure the window stays on the screen
     F=YELLOW : B=RED : FR=2 :                                   ' set the colors and frame
     CALL WindowManager(UR,UC,LR,LC,FR,F,B,_
                        GROW,SHADOW,LABEL,LABEL$,PAGE,SCRMODE)   ' draw the window
     SCRMODE=SS : SS=0                                           ' reset the screen mode (fast/slow)
     CALL CALCATTR(WHITE,RED,ATTR)                               ' set the color for the text in the window
     X=UR : Y=UC+1
        FOR J=1 TO INDEX                                         ' loop thru the array
           IF J=HI THEN CALL CALCATTR(GREY,RED,ATTR)                               ' set the color for the text in the window
           A$=A$(J) : GOSUB Xq                                   ' write the text
           X=X+1                                                 ' increment the row pointer for text
        NEXT J                                                   ' loop til done
     CLICK=0                                                     ' clear the flag
        WHILE NOT CLICK                                          ' wait for a key or click...
        CALL CHECKKEY(MOUSE,CMD,CMD1,LFT,RGT)                    ' in a little loop...
           GOSUB Clock                                           ' so we can keep the clock ticking...
           IF CMD<>0 OR CMD1<>0 OR LFT<>0 OR RGT<>0 THEN CLICK=-1' and the time won't droop.
        WEND                                                     ' poetic, ain't I? (gag!)
     GOSUB RestoreScreen3                                        ' restore the screen snapshot
GaD: ERASE A$:A$="":A1$="":DELIM$="":INDEX=0:ST=0:SLEN=0:J=0     ' clear all these garbage variables
     L=0:R=0:UR=0:UC=0:LR=0:LC=0:F=0:B=0:FR=0:COUNT=0:HI=0       ' clear these too, they're disposable
     RETURN                                                      ' we're all done here

     '--------------------------- data statements ---------------------------

BarMenuData:
     DATA "Memory",2,9
     DATA "EMS",10,14
     DATA "Dynamic",15,23
     DATA "Quit",24,29

LastRowData:
     DATA 8,9,11
'     DATA 8,9,11,12

Menu1Data:
     DATA  Memory
     DATA BLOCKMOVE
     DATA DATASEG
     DATA DYNPTR
     DATA GETEXTM

Menu2Data:
     DATA EMS Memory
     DATA  GETLIMM
     DATA  LOPEN
     DATA  LPUT
     DATA  LGET
     DATA  LCLOSE

Menu3Data:
     DATA Super Arrays
     DATA   DFREAD
     DATA   DFWRITE
     DATA   DGETREC
     DATA   DPUTREC
     DATA   DSORT
     DATA   DSORTB
     DATA   DYNPTR

Menu4Data:
     DATA Virtual Screen
     DATA DCLEAR
     DATA DYNPTR
     DATA DGETSCREEN
     DATA DPUTSCREEN
     DATA DWindowManager
     DATA DXQPRINT
     DATA VGETSCREEN
     DATA VPUTSCREEN

     '------------------------------ descriptions ---------------------------

Menu1Descriptions:
     DATA "",""
     DATA "Copies information from one area of  memory to another.  You supply the|source and  destination segment and offset and the direction.  This can|be used to duplicate arrays."
     DATA " |Example:|CALL BLOCKMOVE(FROMSEG,FROMOFFSET,TOSEG,TOOFFSET,BYTES,DIRECTION)"
     DATA "Returns BASIC's current data segment.  Useful with BLOCKMOVE."
     DATA " |Example: CALL DATASEG(DSEG)"
     DATA "A superset of the VARPTR routine, DYNPTR  returns the  data segment and|offset of a variable or array. Used with Pre-QB4 compilers."
     DATA " |Example:|DV!=VARPTR(ARRAY(1))|CALL DYNPTR(DV!,DSEG,DOFS)"
     DATA "This routine will return the total amount of  extended memory.  This is|useful only on AT-class (80286) machines.  The PCTYPE routine will show|if the machine is an AT. Extended memory is not the same as EMS memory!"
     DATA " |Example: CALL GETEXTM(EXTMEMORY)"

Menu2Descriptions:
     DATA "",""
     DATA "The GETLIMM routine returns the total number of pages and the number of|free (unallocated and available) pages. To convert from pages to K just|multiply by 16."
     DATA " |Example: CALL GETLIMM(TOTPAGES,FREEPAGES)"
     DATA "Opens an area of EMS memory and returns a 'file handle'  for that area.|The variable WORDS specifies the number of elements (up to 65535).  The|variable ECODE will show any error codes, such as insuficient memory."
     DATA " |Example: CALL LOPEN(WORDS,HANDLE,ECODE)"
     DATA "The LPUT routine transfers  data from an array  (STATIC or DYNAMIC)  to|EMS memory.  The variable WORDS determins the number of array  elements|to transfer.  This allows transfers of up to 128K per handle.  DSEG and|DOFS point to the array."
     DATA " |Example: CALL LPUT(HANDLE,DSEG,DOFS,ECODE)"
     DATA "The LGET routine transfers data from EMS memory into an array. It's the|opposite of the LPUT routine."
     DATA " |Example: CALL LGET(HANDLE,DSEG,DOFS,ECODE)"
     DATA "The LCLOSE routine 'closes' the area of EMS memory  so that it is  once|again available for use by BASIC or any other program."
     DATA " |Example: CALL LCLOSE(HANDLE)"

Menu3Descriptions:
     DATA "",""
     DATA "DFREAD is used to read a random access  disk file into a DYNAMIC array.|The data is stored a binary data, not using BASIC's limited 64K  STRING|SPACE.  This assembly language read is far faster than doing an OPEN, a|FIELD, a GET and a LET."
     DATA " |Example:|rem open the file with FOPEN...|rem set the array and get DSEG and DOFS...|CALL DFREAD(HANDLE,DSEG,DOFS,BYTES,BYTESREAD,ERRCODE)"
     DATA "DFWRITE is the opposite of DFREAD and is used to write directly from an|array to a disk file at assembly language speed."
     DATA " |Example:|rem open the file with FOPEN...|rem set the array and get DSEG and DOFS...|CALL DFWRITE(HANDLE,DSEG,DOFS,BYTES,BYTESWRITTEN,ERRCODE)"
     DATA "Gets a record from an array and reads it into a  BASIC string variable.|This allows you to  treat an entire  record as a single block,  without|having to deal with each field in the record."
     DATA " |Example:|ST$=SPACE$(RECLEN)|CALL DGETREC(DSEG,DOFS,RECNR,ST$)"
     DATA "The opposite of DGETREC, DPUTREC puts a  string variable into an  array|record.  Storing string data here does not take up string space."
     DATA " |Example:|$=SPACE$(RECLEN)|CALL DPUTREC(DSEG,DOFS,RECNR,ST$)"
     DATA "Sorts a binary-mode array of records in ascending order. You supply the|array location, record length, number of records to sort, and  the sort|field within the record."
     DATA " |Example:|DSORT(DSEG,DOFS,RECLENGTH,SORTFIELDSTART,SORTFIELDEND,RECORDS)"
     DATA "Sorts a binary-mode array of records in descending order.You supply the|array location, record length, number of records to sort, and  the sort|field within the record."
     DATA " |Example:|DSORTB(DSEG,DOFS,RECLENGTH,SORTFIELDSTART,SORTFIELDEND,RECORDS)"
     DATA "A superset of the VARPTR routine, DYNPTR  returns the  data segment and|offset of a variable or array. Used with many ProBas routines."
     DATA " |Example:|DV!=VARPTR(ARRAY(1))|CALL DYNPTR(DV!,DSEG,DOFS)"

     '--------------------------- misc gosub routines -----------------------

SetBarMouse:
     A=BAR.ROW : B=LMPOS(1) : C=BAR.ROW : D=LMPOS(MAXMENU)       ' use the bar row only
     CALL SETMOUSERANGE(A,B,C,D)                                 ' set the mouse range for the bar row only
     CALL SETMOUSELOC(A,B)                                       ' set the mouse location
     MROW=A : MCOL=B                                             ' set the mouse location variable
     SROW=A : SCOL=B                                             ' set the save mouse location variable
     RETURN

SetMenuMouse:
        IF MENU=0 THEN RETURN
     CALL SETMOUSERANGE(BAR.ROW,ULC(MENU),LRR(MENU),LRC(MENU))   ' set the range to that of the pull-down window
     CALL SETMOUSELOC(ULR(MENU),ULC(MENU))                       ' position the mouse at the first choice
     MROW=ULR(MENU) : MCOL=ULC(MENU)                             ' set the mouse location variable
     SROW=MROW : SCOL=MCOL                                       ' set the save mouse location variable
     MENPOS=ULR(MENU) : MENPOSAVE=MENPOS                         ' save the hilight position
     RETURN

ReColorHighlight:
     CALL CALCATTR(RED,GREY,HIATTR)                              ' the color for the bar highlight
        IF MENU<>0 THEN CALL CALCATTR(BLUE,GREY,HIATTR)          ' the color for the menu highlight. I wonder if anyone notices...
     CALL RECOLORAREA(OROW,OLPOS,OROW,ORPOS,HMATTR,PAGE,SCRMODE) ' reset the previous highlighted choice back to normal
     CALL RECOLORAREA(NROW,NLPOS,NROW,NRPOS,HIATTR,PAGE,SCRMODE) ' set the new highlighted choice
     RETURN

PullDownWindow:
     FORE=LRED  : BACK=BLACK : LABEL=WHITE: FRAME=4             ' set the parms
     CALL DWindowManager(DSEG,DOFS,ULR,ULC,LRR,LRC,FRAME,FORE,_
                         BACK,GROW,SHADOW,LABEL,LABEL$)         ' draw window to virtual screen
     CALL CALCATTR(LCYAN,BLUE,ATTR)                             ' set the current color
     HMATTR=ATTR                                                ' set the main text color
     CALL CALCATTR(BLUE,GREY,HIATTR)                            ' set the highlight color
     RETURN

ClearCommand:
     COLOR GREY,BLACK                                           ' default color
     X=23 : Y=1                                                 ' row 23, column 1
        FOR X=25 TO 23 STEP-1                                   ' do it backwards from row 25...
           LOCATE X,Y,0                                         ' locate the cursor pos with it off
           CALL CLREOL                                          ' clear the line
        NEXT X                                                  ' and end on row 23, column 1, ready to display a prompt
     RETURN

     '------------------- clean up and return to main menu ------------------

Quit:
     GOSUB RestoreScreen                                         ' restore the main menu screen
     RESTART=-1                                                  ' set restart flag
     CHAIN "DEMO"                                                ' do the chain

     '------------------------ standard sub-routines ------------------------

SaveScreen:
     CALL DSCRSAVE(VARSEG(SCR1(1)),VARPTR(SCR1(1)),PAGE,SCRMODE)
     RETURN

RestoreScreen:
     CALL DSCRREST(VARSEG(SCR1(1)),VARPTR(SCR1(1)),PAGE,SCRMODE)
     RETURN

SaveScreen2:
     CALL DSCRSAVE(VARSEG(SCR2(1)),VARPTR(SCR2(1)),PAGE,SCRMODE)
     RETURN

RestoreScreen2:
     CALL DSCRREST(VARSEG(SCR2(1)),VARPTR(SCR2(1)),PAGE,SCRMODE)
     RETURN

SaveScreen3:
     CALL DSCRSAVE(VARSEG(SCR3(1)),VARPTR(SCR3(1)),PAGE,SCRMODE)
     RETURN

RestoreScreen3:
     CALL DSCRREST(VARSEG(SCR3(1)),VARPTR(SCR3(1)),PAGE,SCRMODE)
     RETURN

SaveScreen4:
     CALL DSCRSAVE(VARSEG(SCR4(1)),VARPTR(SCR4(1)),PAGE,SCRMODE)
     RETURN

RestoreScreen4:
     CALL DSCRREST(VARSEG(SCR4(1)),VARPTR(SCR4(1)),PAGE,SCRMODE)
     RETURN

Xq:  CALL XQPRINT(A$,X,Y,ATTR,PAGE,SCRMODE)
     RETURN

DXq: CALL DXQPRINT(DSEG,DOFS,A$,X,Y,ATTR)
     RETURN

KeyClick:
     CLICK=0                                                     ' clear exit flag
        WHILE NOT CLICK                                          ' loop
           GOSUB Clock                                           ' update time display
           CALL CHECKKEY(MOUSE,CMD,CMD1,LFT,RGT)                 ' check for a keypress or mouse click
           IF CMD<>0 OR CMD1<>0 OR LFT<>0 OR RGT<>0 THEN CLICK=-1' did we get one?  if so set exit flag
        WEND                                                     ' loop
     RETURN

Clock:
        IF CLOCKOFF THEN RETURN
     XX=X : YY=Y : X=25 : Y=72                                   ' save current x/y value and set to new loc
     CALL XQPRINT(TIME$,X,Y,TIMATTR,PAGE,SCRMODE)                ' update the time every loop
     X=XX : Y=YY                                                 ' restore the x/y values
     RETURN                                                      ' tick tock.
