     DEFINT A-Z
     rem $STATIC:
     DIM SCR1(2000),SCR2(2000),SCR3(2000)

     rem $INCLUDE: 'COMDEF.BAS'

     DEF SEG=0
     PAGE=0
     LOCATE 23,1,0                                               ' locate and turn off the cursor
     CALL CALCATTR(RED,GREY,HIATTR)                              ' set the highlight color
     CALL CALCATTR(YELLOW,RED,HMATTR)                            ' set the normal color
     CALL CALCATTR(RED,BLACK,TIMATTR)                            ' set the color for the on-screen clock

     '---------------------------- set up the screen ------------------------

     ' This is basically a repeat of DEMO3.BAS 'cause
     ' I ran out of ideas.  Just how many interesting
     ' ways can you present this kind of data without
     ' things getting too crazy?                                 ' rhetorical question

     GOSUB SaveScreen                                            ' save the current screen in SCR1()
     DSEG=VARSEG(SCR2(1))                                        ' get segment
     DOFS=VARPTR(SCR2(1))                                        ' get offset
     CALL CALCATTR(LCYAN,RED,ATTR)                               ' calculate the color attribute
     CALL DCLEAR(DSEG,DOFS,ATTR)                                 ' clear the virtual screen (CLS)
     CALL CALCATTR(RED,BLACK,ATTR)                               ' color for frame
     ULR=3 : ULC=4 : LRR=23 : LRC=77 : FRAME=1                   ' set window position
     FORE=LCYAN : BACK=RED : LABEL=WHITE                         ' set the colors
     LABEL$="Advanced Programming Routines"                      ' and the lable
     GOSUB DWindowManager                                        ' draw the window
     A1$=STRING$(80,176) : A2$=STRING$(2,176)                    ' let's do some text graphics
     X=1 : Y=1                                                   ' start at the top
     A$=A1$ : GOSUB DXq                                          ' draw line at top
     X=25   : GOSUB DXq                                          ' draw line at bottom
     A$=A2$                                                      ' use a 2 char boarder
        FOR X=1 TO 25                                            ' draw the boarder...
           Y=1 : GOSUB DXq                                       ' on the left left..
           Y=79: GOSUB DXq                                       ' and the right
        NEXT X                                                   ' til done

     rem $DYNAMIC
     REDIM LTPOS(6),RTPOS(6)                                     ' a temp array for positions
     RESTORE MenuPos                                             ' restore the data
        FOR I=1 TO 6                                             ' loop thru
           READ LTPOS(I)                                         ' left side of each column
           READ RTPOS(I)                                         ' right side of each column
        NEXT I

     RESTORE MenuChoices                                         ' restore the data
     READ CHOICES                                                ' read the number of menu choices
     REDIM MENU$(CHOICES),LMROW(CHOICES)                         ' arrays for menu text and row
     REDIM LMPOS(CHOICES),RMPOS(CHOICES)                         ' permanent l/r columns
     RESTORE MenuData                                            ' restore the menu choice data
     INDEX=0 : X=4                                               ' set pointers
     CALL CALCATTR(YELLOW,RED,ATTR)                              ' set color
        FOR I=1 TO CHOICES                                       ' loop thru the menu choices
           INDEX=INDEX+1                                         ' keep a column index
           IF INDEX=7 THEN INDEX=1 : X=X+1                       ' if we get to the far right, reset and increment row
           LMROW(I)=X                                            ' save the row
           LMPOS(I)=LTPOS(INDEX)                                 ' save the left side of column
           RMPOS(I)=RTPOS(INDEX)                                 ' save the right side of column
           Y=LMPOS(INDEX)+1                                      ' set the y pos for the display
           READ A$ : GOSUB DXq                                   ' read and write the menu choice
           MENU$(I)=A$                                           ' store in an array
        NEXT I                                                   ' loop til done
     ERASE LTPOS,RTPOS                                           ' erase the temp arrays

     CALL DPUTSCREEN(DSEG,DOFS,1,1,25,80,PAGE,SCRMODE)           ' display the main screen
     CALL CALCATTR(GREY,RED,ATTR) : Y=6                         ' display some help text...
     X=22 : A$="Use the arrow keys or the mouse to highlight a routine and press Enter" : GOSUB Xq
     X=23 : A$="or click a mouse button for a description." : GOSUB Xq
     A=WHITE+16 : CALL CALCATTR(A,RED,ATTR)                      ' set for blinking hi-intensity white text
     Y=50 : A$="Press any key to begin:" : GOSUB Xq              ' prompt 'em
     CALL GETKEY(MOUSE,CMD,CMD1,LFT,RGT)                         ' waint for key or click
     CALL DPUTSCREEN(DSEG,DOFS,1,1,25,80,PAGE,SCRMODE)           ' redisplay without the help text
     CALL RECOLORAREA(4,LMPOS(1),4,RMPOS(1),HIATTR,PAGE,SCRMODE) ' set the 1st choice to highlighted
     CALL CALCATTR(GREY,RED,ATTR)
     MENPOS=1 : MENPOSAVE=1                                      ' remember the current highlighted choice
     X=12 : A$="Assembly in UPPER CASE  -  Basic in Upper/Lower Case"
     Y=40-LEN(A$)\2 : GOSUB Xq                                   ' center the text (integer divide)

        IF MOUSE THEN GOSUB SetMainMouse                         ' set mouse range for the data area

     '------------------------------ main command ---------------------------

MainCom:                                                         ' the main keyboard/mouse input routine
     CLICK=0                                                     ' clear the flag
        WHILE NOT CLICK                                          ' wait for a keypress or a mouse click
           CALL CHECKKEY(MOUSE,CMD,CMD1,LFT,RGT)                 ' check for keypress or mouse click
           IF MOUSE THEN GOSUB Mouse                             ' check to see if the mouse has been moved
           IF CMD<>0 OR CMD1<>0 OR LFT<>0 OR RGT<>0 THEN CLICK=-1' if a keypress or mouse click then exit the while/wend loop
        WEND                                                     ' keep on truckin'
        IF CMD=27 THEN GOTO Quit                                 ' quit
        IF CMD=13 AND MENPOS=CHOICES THEN GOTO Quit              ' quit
        IF LFT<>0 AND MENPOS=CHOICES THEN GOTO Quit              ' quit
        IF CMD=13 OR LFT<>0 THEN GOTO Descriptions               ' Enter or left mouse
        IF CMD1=75 THEN GOTO LeftArrow                           ' left arrow
        IF CMD1=77 THEN GOTO RightArrow                          ' right arrow
        IF CMD1=72 THEN GOTO UpArrow                             ' up arrow
        IF CMD1=80 THEN GOTO DownArrow                           ' down arrow
        IF CMD1=71 THEN GOTO Top                                 ' Home key
        IF CMD1=79 THEN GOTO Bottom                              ' end key
     GOTO MainCom

Mouse:
     CALL GETMOUSELOC(MROW,MCOL)
        IF MROW=SROW AND MCOL=SCOL THEN RETURN
     Z=0
        FOR I=1 TO CHOICES
           IF MROW=LMROW(I) THEN IF MCOL=>LMPOS(I) AND MCOL<=RMPOS(I) THEN Z=I
        NEXT I
        IF Z<>MENPOS AND Z>0 AND Z=<CHOICES THEN MENPOS=Z
     GOSUB ReColorHighlight
     SROW=MROW : SCOL=MCOL
     RETURN

LeftArrow:
        IF MENPOS=1 THEN MENPOS=CHOICES+1
     MENPOS=MENPOS-1
     GOTO DoTheReColor

RightArrow:
        IF MENPOS=CHOICES THEN MENPOS=0
     MENPOS=MENPOS+1
     GOTO DoTheReColor

UpArrow:
        IF MENPOS<7 THEN GOTO MainCom
     MENPOS=MENPOS-6
     GOTO DoTheReColor

DownArrow:
     MENPOS=MENPOS+6
        IF MENPOS>CHOICES THEN GOTO MainCom
     GOTO DoTheReColor

Top:
     MENPOS=1
     GOTO DoTheReColor

Bottom:
     MENPOS=CHOICES
     GOTO DoTheReColor

DoTheReColor:
     GOSUB ReColorHighlight
        IF MOUSE THEN
           CALL SETMOUSELOC(NROW,NLPOS)
           MROW=NROW : MCOL=NLPOS
           SROW=MROW : SCOL=MCOL
        END IF
     GOTO MainCom

     '------------------------------- descriptions --------------------------

Descriptions:
     GOSUB SaveScreen3
     RESTORE DescriptionData
     TABLE$=""                                                   ' clear the string
        FOR I=0 TO 255                                           ' loop thru the full ASCII set
           TABLE$=TABLE$+CHR$(I)                                 ' assigning a character to string in
        NEXT I                                                   ' the proper position
     MID$(TABLE$,95,1)=CHR$(34)                                  ' now set the " character to a ^
        FOR J=1 TO MENPOS                                        ' read thru the data statements...
           READ A$,A1$                                           ' til we reach the one we want...
        NEXT J                                                   ' now we have it!
     CALL XLATE(A$,TABLE$)                                       ' translate a$
     CALL XLATE(A1$,TABLE$)                                      ' translate a1$
     REDIM A$(20)                                                ' set up an array for text descriptions
     SLEN=1 : INDEX=0                                            ' set/clear pointers
     DELIM$="|"                                                  ' specify the delimiter
        WHILE SLEN>0                                             ' loop
           INDEX=INDEX+1                                         ' increment the pointer
           CALL EXTRACT(A$,DELIM$,INDEX,ST,SLEN)                 ' do the call
           A$(INDEX)=MID$(A$,ST,SLEN)                            ' load the delimited string into array
        WEND                                                     ' loop til done
     UR=16 : UC=10 : LR=UR+INDEX-2 : LC=69                       ' use different variables so we don't mess up the menu vars!
     F=LRED: B=BLACK : FR=2 : LABEL=WHITE                        ' set colors
     LABEL$=MENU$(MENPOS)                                        ' label the window with the menu choice
     CALL WindowManager(UR,UC,LR,LC,FR,F,B,_
                        GROW,SHADOW,LABEL,LABEL$,PAGE,SCRMODE)   ' draw the window
     CALL CALCATTR(CYAN,BLACK,ATTR)                              ' set the color for the text in the window
     X=UR : Y=UC+1                                               ' set x/y pos for text
        FOR J=1 TO INDEX                                         ' loop thru the array
           A$=A$(J) : GOSUB Xq                                   ' write the text
           X=X+1                                                 ' increment the row pointer for text
        NEXT J                                                   ' loop til done
     CLICK=0                                                     ' clear the flag
        WHILE NOT CLICK                                          ' wait for a key or click...
        CALL CHECKKEY(MOUSE,CMD,CMD1,LFT,RGT)                    ' in a little loop...
           IF CMD<>0 OR CMD1<>0 OR LFT<>0 OR RGT<>0 THEN CLICK=-1' and the time won't droop.
        WEND                                                     ' poetic, ain't I? (gag!)
     GOSUB RestoreScreen3                                        ' restore the screen snapshot

     CALL CALCATTR(LCYAN,RED,ATTR)
     X=14 : Y=5 : A$="Example:" : GOSUB Xq
     REDIM A$(20)                                                ' set up an array for text descriptions
     SLEN=1 : INDEX=0                                            ' set/clear pointers
        WHILE SLEN>0                                             ' loop
           INDEX=INDEX+1                                         ' increment the pointer
           CALL EXTRACT(A1$,DELIM$,INDEX,ST,SLEN)                ' do the call
           A$(INDEX)=MID$(A1$,ST,SLEN)                           ' load the delimited string into array
        WEND                                                     ' loop til done
     Y=10
        FOR I=1 TO INDEX
           A$=A$(I) : X=X+1 : GOSUB Xq
        NEXT I
     CLICK=0                                                     ' clear the flag
        WHILE NOT CLICK                                          ' wait for a key or click...
        CALL CHECKKEY(MOUSE,CMD,CMD1,LFT,RGT)                    ' in a little loop...
           IF CMD<>0 OR CMD1<>0 OR LFT<>0 OR RGT<>0 THEN CLICK=-1' and the time won't droop.
        WEND                                                     ' poetic, ain't I? (gag!)
     GOSUB RestoreScreen3                                        ' restore the screen snapshot
     ERASE A$:A$="":DELIM$="":INDEX=0:ST=0:SLEN=0:J=0:L=0:R=0    ' clear all these garbage variables
     WROW=0:WCOL=0:UR=0:UC=0:LR=0:LC=0:F=0:B=0:FR=0              ' clear these too, they're disposable
     GOTO MainCom                                                ' we're all done here

     '----------------------------- data statements -------------------------


MenuPos:
     DATA 5,16,17,28,29,40,41,52,53,63,65,76

MenuChoices:
     DATA 30

MenuData:
     DATA ADDMATI
     DATA ANY2DEC
     DATA CARRIER
     DATA DEC2ANY
     DATA DELAY
     DATA DELAY18TH
     DATA DISKSTAT
     DATA DTR
     DATA EQUIPMENT
     DATA MONTH
     DATA GETCRT
     DATA GETDOSV
     DATA GETEGA
     DATA GETEXTM
     DATA GETLIMM
     DATA GETTIME
     DATA GETVIDMODE
     DATA NumFormat
     DATA PCTYPE
     DATA PRTCHECK
     DATA PRTSWAP
     DATA READBITF
     DATA SETCOMM
     DATA SETMATI
     DATA SHIFTL
     DATA SHIFTR
     DATA SPEAKER
     DATA WEEKDAY
     DATA WRITEBITF
     DATA quit

DescriptionData:
     DATA "Adds a integer value to the  first specified section of an|array.  You can  subtract by  adding a negative number. If|result is outside integer range, the overflow flag is set."
     DATA "DIM ARRAY(10000) : SIZ=10000 : ADDVAL=-6|CALL ADDMATI(ARRAY(1),SIZ,ADDVAL,OVERFLOW)|rem - we just subtracted 6 from each element in the array"

     DATA "Converts a number in string format from any base (2-35) to|a decimal integer (base 10). Number may be either a signed|or unsigned integer. The routine DEC2ANY does the reverse."
     DATA "INPUT ^Number, base of number: ^,ANUM$,NBASE|CALL ANY2DEC(ANUM$,NBASE,DNUM,ECODE)|rem - result returned in DNUM|rem - if an error, ECODE will be non-zero"

     DATA "Returns the status of the modem Carrier Detect signal. You|may specify communications port one or two."
     DATA "COMMPORT=1|CALL CARRIER(COMMPORT,CDSTATUS)|rem - if CDSTATUS is non-zero, there is a carrier detected"

     DATA "Converts a number from decimal (base 10) to any other base|(2-35). Number will be converted to an unsigned integer to|conform with BASIC's HEX$ and OCT$ functions."
     DATA "INPUT ^Decimal number, to base: ^,DNUM,NBASE|ANUM$=STRING$(16,^0^)|CALL DEC2ANY(DNUM,NBASE,ANUM$,ALEN)|ANUM$=LEFT$(ANUM$,ALEN)|rem - if ALEN=0 then a bad base or ANUM$ is too short|rem - result returned in ANUM$"

     DATA "A routine to pause or delay n number of seconds.  Uses the|computer clock so the delay will be the same  on a 4.77Mhz|PC as on a 12Mhz AT."
     DATA "SECONDS=3|CALL DELAY(SECONDS)|rem - pause for 3 seconds"

     DATA "A routine to pause or  delay n number of 18ths of a second|Uses the computer clock so the delay will be the same on a|4.77Mhz PC as on a 12Mhz AT.   The clock is  accurate only|to 1/18th second."
     DATA "MINIDELAY=9              ' 9/18th = 1/2 second|CALL DELAY18TH(MINIDELAY)|rem - pause for one half second"

     DATA "Returns various  information about  the disk including the|total  number of disk  clusters,  number of free clusters,|number of bytes per sector,  and the number of sectors per|cluster.  Used for detailed disk size information."
     DATA "CALL DISKSTAT(DRV$,FREE.CLUST,TOTAL.CLUST,BYTES.SEC,SECS.CLUST)|CLUSTER.SIZE# = CDBL(BYTES.SEC) * CDBL(SECS.CLUST)|FREE.DISK.SPACE# = CDBL(FREE.CLUST) * CLUSTER.SIZE#|TOTAL.DISK.SPACE# = CDBL(TOTAL.CLUST) * CLUSTER.SIZE#"

     DATA "Switches the comm signal DTR (Data Terminal Ready) on/off.|Turning DTR off makes most modems drop carrier and hang up|the phone. Set to 0 to turn DTR off, or -1 to turn it on."
     DATA "COMMPORT=1 : TOGGLE=0|CALL DTR(COMMPORT,TOGGLE)|rem - toggle=0 means turn DTR off (drop carrier)."

     DATA "Returns information about the hardware being used, such as|the amount of base memory,  number of serial ports, number|of parallel ports, and number of game ports."
     DATA "CALL EQUIPMENT(MEMORY,PARALLEL,SERIAL,GAME)"

     DATA "Given the number of the month (1-12), the  routine returns|the name of the month (January - December)"
     DATA "MONTH$=SPACE$(9)|MONTH=3    ' third month|CALL MONTH(MONTH$,MLEN,MONTH)|MONTH$=LEFT$(MONTH$,MLEN)|rem - MONTH$ now equals March"

     DATA "Returns the type of monitor in use (color or monochrome)."
     DATA "CALL GETCRT(COLORDISPLAY)"

     DATA "Returns both the major and minor version of DOS."
     DATA "CALL GETDOSV(MAJ,MIN)|DOS$=MID$(STR$(MAJ),2)|DOS$=DOS$+^.^+MID$(STR$(MIN),2)"

     DATA "Returns non-zero if EGA-equipped AND running EGA mode."
     DATA "CALL GETEGA(EGA)|rem - non-zero means EGA"

     DATA "Returns the amount of AT Extended memory."
     DATA "CALL GETEXTM(EXTMEMORY)|rem - returned in kilobytes"

     DATA "Returns information  about EMS memory, including the total|number of  pages and the  number of free pages.  Note that|this also works with EEMS memory."
     DATA "CALL GETLIMM(TOTPAGES,FREEPAGES)|TOTALEMS=TOTPAGES*16   ' convert to kilobytes|FREEEMS=FREEPAGES*16   ' convert to kilobytes"

     DATA "Returns the current time in hundredths of a second. Due to|hardware limitations on some systems, this may be accurate|only to within 1/18th of a second."
     DATA "CALL GETTIME(HOUR,MIN,SEC,HUNDREDTHSEC)"

     DATA "Returns the current video mode,  screen width,  and screen|page."
     DATA "CALL GETVIDMODE(VMODE,VWIDTH,VPAGE)

     DATA "BASIC subroutine that  redirects the PRINT USING output to|a string.  Eliminates using the screen or a disk file."
     DATA "CALL NumFormat(FORMAT$,NUMBER#,RESULT$)|rem - FORMAT$ uses the same format as PRINT USING|rem - RESULT$ now contains the formatted number"

     DATA "Returns the hardware type as  shown by the ROM BIOS.  Note|that this may not return the expected value for some close|compatibles."
     DATA "CALL PCTYPE(TYPE)|rem - 255  PC or XT|rem - 254  XT or Portable|rem - 253  PC Jr.|rem - 252  PC/AT|rem - 154  Compaq I|rem -  45  Compaq I"

     DATA "Checks the specified parallel printer port to see if there|is a printer online and ready to print."
     DATA "CALL PRTCHECK(PRTPORT,STATUS)|rem - if STATUS is non-zero, printer is not ready"

     DATA "Swaps the parallel port associated with two printers. This|may not work with some print cache utilities.  The changes|are permanent, even after exiting the BASIC program."
     DATA "CALL PRTSWAP(FIRSTPORT,SECONDPORT)|rem - example swaps from FIRSTPORT to SECONDPORT"

     DATA "Reads a word from an array  of arbitrary length,  given an|index. The words in the array may be of one to eight bits.|Allows very memory-efficient  storage of  numbers that are|in the restricted range (up to 255)."
     DATA "DIM ARRAY(50) : BITSIZE=8|CALL READBITF(ARRAY(0),NDX,BITSIZE,VALUE)|rem - returns VALUE from the location indexed by NDX"

     DATA "Sets the comm parameters on an opened communications port.|Allows setting a higher  baud rate than  BASIC allows, and|changing the comm  parameters without  having to close the|comm device."
     DATA "COMMPORT=1 : BPS=6 : PARITY=0 : WORDLENGTH=8 : STOPBITS=1|CALL SETCOMM(COMMPORT,BPS,PARITY,WORDLENGTH,STOPBITS)|rem - port is set to 19200 baud, no parity, 8 bit words, 1 stop bit"

     DATA "Sets the first specified elements of an integer array to a|given value.  On  multi-dimensional  arrays, the  leftmost|dimension increments first."
     DATA "DIM ARRAY(9) : SIZ=10 : INITVAL=-3|CALL SETMATI(ARRAY(1),SIZ,INITVAL)|rem - we have just initialized all 10 elements of the array|rem - to the value of -3"

     DATA "Shifts all the bits in an integer left COUNT times,putting|zeros in the bit  positions which have been vacated.  This|effectively multiplies  the value by a  power of 2 in most|instances.  For programmers who know what it's good for."
     DATA "VALUE=47 : COUNT=3|CALL SHIFTL(VALUE,COUNT)|rem - shifts VALUE left three bits|rem - in this case getting 47*2^3 or 376"

     DATA "The same as SHIFTL,  but shifts the bits right  instead of|left.  This is similar in effect to an integer divide by a|power of two."
     DATA "VALUE=47 : COUNT=3|CALL SHIFTR(VALUE,COUNT)|rem - shifts VALUE right three bits|rem - in this case getting 47/2^3 or 5"

     DATA "Enables you to turn the speaker on  or off so that you can|disable sound effects for a program.   Sound routines will|still be executed, but will  produce no sound if it's off.|Routines will run at the same speed if speaker is off."
     DATA "SPKR=0             ' 0 = off  non-zero = on|CALL SPEAKER(SPKR)|rem - this would turn the speaker off|rem - may not work on some AT - clones or the PC Jr."

     DATA "Returns an integer from 1-7 indicating the day of the week|as per the system time/date clock."
     DATA "CALL WEEKDAY(DAY%)|DLEN% = VAL(MID$(^3346535^,DAY,1))|DLOC% = ASC(MID$(^ADGKQVY^,DAY%))-64|PRINT ^Today is^;|PRINT MID$(^SunMonTuesWednesThursFriSatur^,DLOC%,DLEN%);^day.^

     DATA "Allows a value to be written to a given location of a sim-|ulated array of words of  arbitrary length (1-8 bits per).|This goes with the  READBITF  function.  Creates fields of|arbitrary length within what is actually an integer array."
     DATA "CALL WRITEBITF(ARRAY(0),NDX,BITFSIZE,VALUE)|rem - not recommended for novice programmers!"

     '--------------------------- misc gosub routines -----------------------

DWindowManager:
     CALL DWindowManager(DSEG,DOFS,ULR,ULC,LRR,LRC,FRAME,FORE,_
                         BACK,GROW,SHADOW,LABEL,LABEL$)
     RETURN

WindowManager:
     CALL WindowManager(ULR,ULC,LRR,LRC,FRAME,FORE,BACK,_
                        GROW,SHADOW,LABEL,LABEL$,PAGE,SCRMODE)
     RETURN

ReColorHighlight:
     OROW=LMROW(MENPOSAVE) : OLPOS=LMPOS(MENPOSAVE)
     ORPOS=RMPOS(MENPOSAVE): NROW=LMROW(MENPOS)
     NLPOS=LMPOS(MENPOS)   : NRPOS=RMPOS(MENPOS)
     CALL RECOLORAREA(OROW,OLPOS,OROW,ORPOS,HMATTR,PAGE,SCRMODE) ' reset the previous highlighted choice back to normal
     CALL RECOLORAREA(NROW,NLPOS,NROW,NRPOS,HIATTR,PAGE,SCRMODE) ' set the new highlighted choice
     MENPOSAVE=MENPOS
     RETURN

SetMainMouse:
     A=LMROW(1) : B=LMPOS(1) : C=LMROW(CHOICES) : D=RMPOS(6)+3    ' set area of screen mouse can use
     CALL SETMOUSERANGE(A,B,C,D)                                 ' tell the mouse
     CALL SETMOUSELOC(A,B)                                       ' position on the first choice
     MROW=A : MCOL=B                                             ' the current mouse pos
     SROW=A : SCOL=B                                             ' the save mouse pos for comparisons
     RETURN                                                      ' done

     '------------------- clean up and return to main menu ------------------

Quit:
     GOSUB RestoreScreen                                         ' restore the main menu screen
     RESTART=-1                                                  ' set restart flag
     CHAIN "DEMO"                                                ' do the chain

     '------------------------ standard sub-routines ------------------------

SaveScreen:
     CALL DSCRSAVE(VARSEG(SCR1(1)),VARPTR(SCR1(1)),PAGE,SCRMODE)
     RETURN

RestoreScreen:
     CALL DSCRREST(VARSEG(SCR1(1)),VARPTR(SCR1(1)),PAGE,SCRMODE)
     RETURN

SaveScreen2:
     CALL DSCRSAVE(VARSEG(SCR2(1)),VARPTR(SCR2(1)),PAGE,SCRMODE)
     RETURN

RestoreScreen2:
     CALL DSCRREST(VARSEG(SCR2(1)),VARPTR(SCR2(1)),PAGE,SCRMODE)
     RETURN

SaveScreen3:
     CALL DSCRSAVE(VARSEG(SCR3(1)),VARPTR(SCR3(1)),PAGE,SCRMODE)
     RETURN

RestoreScreen3:
     CALL DSCRREST(VARSEG(SCR3(1)),VARPTR(SCR3(1)),PAGE,SCRMODE)
     RETURN

Xq:  CALL XQPRINT(A$,X,Y,ATTR,PAGE,SCRMODE)
     RETURN

DXq: CALL DXQPRINT(DSEG,DOFS,A$,X,Y,ATTR)
     RETURN

