     DEFINT A-Z
     rem $STATIC:
     DIM SCR1(2000),SCR2(2000),SCR3(2000)

     rem $INCLUDE: 'COMDEF.BAS'

     DEF SEG=0
     PAGE=0
     LOCATE 23,1,0                                               ' locate and turn off the cursor
     CALL CALCATTR(MAG,BLACK,TIMATTR)                            ' set the color for the on-screen clock

     '--------------------------- WindowManager demo ------------------------

     ' In this module we will allow the user to create their
     ' own windows.  We begin as we always do, by saving the
     ' current screen so we can restore it when we're done.

     GOSUB SaveScreen                                            ' save the main screen for return

     ' Now we'll display some information in the boxes
     ' that normally contain the menu and the calendar...

     ULR=7 : ULC=3 : LRR=20 : LRC=39                             ' position of window
     BACK=MAG : GROW=-1                                          ' no frame, and exploding
     GOSUB WindowManager                                         ' draw window
     Y=5 : CALL CALCATTR(LCYAN,MAG,ATTR)                         ' set column and color
        FOR X=8 TO 16                                            ' loop thru
           READ A$ : GOSUB Xq                                    ' reading and writing text
        NEXT X                                                   ' til done
     X=19: CALL CALCATTR(WHITE,MAG,ATTR)                         ' set up a high intensity color
     READ A$ : GOSUB Xq                                          ' read 1 more line
     GOSUB KeyClick                                              ' wait for key or click

     BACK=CYAN : GROW=0                                          ' change the window's color and don't grow
     GOSUB WindowManager                                         ' draw window
     Y=4 : CALL CALCATTR(WHITE,CYAN,ATTR)                        ' set col and color
        FOR X=7 TO 17                                            ' rows
           READ A$ : GOSUB Xq                                    ' read and write
        NEXT X                                                   ' til done
     CALL CALCATTR(YELLOW,CYAN,ATTR)                             ' hi intensity color line
     X=19: Y=8 : A$="Press any key to continue" : GOSUB Xq       ' help message
     GOSUB KeyClick                                              ' wait for key or click

     Y=4 : CALL CALCATTR(GREY,BLUE,ATTR)                         ' set col and color
     BACK=BLUE : GROW=0                                          ' change window background
     GOSUB WindowManager                                         ' draw window
        FOR X=7 TO 15                                            ' loop thru rows
           READ A$ : GOSUB Xq                                    ' reading and writing
        NEXT X                                                   ' till done
     CALL CALCATTR(WHITE,BLUE,ATTR)                              ' set example color
     X=17: READ A$ : GOSUB Xq                                    ' read and write
     X=18: READ A$ : GOSUB Xq                                    ' read and write
     CALL CALCATTR(GREY,BLUE,ATTR)                               ' set help line color
     X=20: READ A$ : GOSUB Xq                                    ' display help line

     ULR=7 : ULC=43: LRR=20 : LRC=78                             ' set pos for right window
     BACK=RED                                                    ' set color
     GOSUB WindowManager                                         ' draw window
     Y=46: CALL CALCATTR(WHITE,RED,ATTR)                         ' set text color
     X=7 : READ A$ : GOSUB Xq                                    ' read text
     CALL CALCATTR(LCYAN,RED,ATTR)                               ' set another color
        FOR X=9 TO 19                                            ' loop thru rows
           READ A$ : GOSUB Xq                                    ' read and write
        NEXT X                                                   ' til done
     GOSUB KeyClick                                              ' wait for key or click

SetUpWindow:
     Y=2 : CALL CALCATTR(GREY,BLACK,ATTR)
     X=23: A$="Remember to allow for the frame.   To speed execution, WindowManager does NOT" : GOSUB Xq
     X=24: A$="check to see if the arguments are valid.  Never specify a RIGHT value to  the ": GOSUB Xq
     X=25: A$="left of the LEFT column or a BOTTOM row above the TOP row." : GOSUB Xq

     ' Here is where they are prompted for the various
     ' WindowManager arguments...

     ULR=7 : ULC=3 : LRR=20 : LRC=39 : FRAME=0
     FORE=GREY : BACK=BLACK : GROW=-1
     GOSUB WindowManager
     Y=6 : CALL CALCATTR(WHITE,BLACK,ATTR)
     X=7 : A$="Enter a value, then press Enter" : GOSUB Xq
     Y=4 : CALL CALCATTR(LCYAN,BLACK,ATTR)
     X=9 : A$="ULR    (2-24):" : GOSUB Xq
     X=10: A$="ULC    (2-77):" : GOSUB Xq
     X=11: A$="LRR    (2-24):" : GOSUB Xq
     X=12: A$="LRC    (2-79):" : GOSUB Xq
     X=13: A$="FRAME  (0-4) :" : GOSUB Xq
     X=14: A$="FORE   (0-32):" : GOSUB Xq
     X=15: A$="BACK   (0-7) :" : GOSUB Xq
     X=16: A$="LABEL  (0-32):" : GOSUB Xq
     X=17: A$="LABEL$ (text):" : GOSUB Xq
     X=18: A$="GROW   (y/n) :" : GOSUB Xq
     X=19: A$="SHADOW (y/n) :" : GOSUB Xq

     ' We wrote a simple input routine at the label
     ' "GetInput" to handle the input for each parm

     ULR=7 : ULC=20 : LRR=17 : LRC=60                            ' set defaults if they
     FORE=WHITE : BACK=RED   : FRAME=2                           ' press enter
     COLOR GREY,BLACK : STARTCOL=19 : MAXLEN=2                   ' set color, cursor pos, and length of input
     X=9 : GOSUB GetInput : IF B$<>"" THEN ULR=VAL(B$)
     LOCATE X,STARTCOL : PRINT ULR;
     X=10: GOSUB GetInput : IF B$<>"" THEN ULC=VAL(B$)
     LOCATE X,STARTCOL : PRINT ULC;
     X=11: GOSUB GetInput : IF B$<>"" THEN LRR=VAL(B$)
     LOCATE X,STARTCOL : PRINT LRR;
     X=12: GOSUB GetInput : IF B$<>"" THEN LRC=VAL(B$)
     LOCATE X,STARTCOL : PRINT LRC;

     ' this next routine specifies the position of
     ' a shadowed window for help.  We use some throw-
     ' away variables so as to not interfere with the
     ' window they are building.  We then take a
     ' snapshot of the area that thw window will over-
     ' write so we can restore it.  Normally we just
     ' allow for the frame, but this time we also have
     ' to allow for the shadow.  The snapshot will be
     ' stored in the array SCR3().

     A=5 : B=50  : C=13  : D=77  : E=2 : F=-1
     G=-1: AA=A-1: BB=B-3: CC=C+3: DD=D+1
     DSEG = VARSEG(SCR3(1))
     DOFS = VARPTR(SCR3(1))
     CALL DGETSCREEN(DSEG,DOFS,AA,BB,CC,DD,PAGE,SCRMODE)

     ' This jumps to subroutine at the end of this
     ' section that displays help information about
     ' the types of frames available.  The window that
     ' the subroutine draws uses the positions specified
     ' in the lines just above this text.

     GOSUB FrameHelp
     X=13: GOSUB GetInput : IF B$<>"" THEN FRAME=VAL(B$)
     LOCATE X,STARTCOL : PRINT FRAME;

     ' This jumps to another subroutine that provides
     ' help on the colors.

     GOSUB ColorHelp
     X=14: GOSUB GetInput : IF B$<>"" THEN FORE=VAL(B$)
     LOCATE X,STARTCOL : PRINT FORE;
     X=15: GOSUB GetInput : IF B$<>"" THEN BACK=VAL(B$)
     LOCATE X,STARTCOL : PRINT BACK;
     LABEL=YELLOW : LABEL$="Window"
     X=16: GOSUB GetInput : IF B$<>"" THEN LABEL=VAL(B$)

     ' We restore the area of screen that the two help
     ' windows overwrote and continue

     DSEG = VARSEG(SCR3(1))
     DOFS = VARPTR(SCR3(1))
     CALL DPUTSCREEN(DSEG,DOFS,AA,BB,CC,DD,PAGE,SCRMODE)
     MAXLEN=20                                                   ' allow 20 chars of input
     X=17: GOSUB GetInput : IF B$<>"" THEN LABEL$=B$             ' get the input
     MAXLEN=1                                                    ' allow 1 char of input
     LOCATE 18,19,1 : GOSUB KeyClick                             ' locate and get input
     CMD$=CHR$(CMD) : CALL UPCASE(CMD$)                          ' convert input to upper case
     GROW=(CMD$="Y"): IF NOT GROW THEN CMD$="N"                  ' set GROW variable and print N if input <>Y
     PRINT CMD$                                                  ' display input
     LOCATE 19,19,1   : GOSUB KeyClick                           ' position cursor and get input
     CMD$=CHR$(CMD)   : CALL UPCASE(CMD$)                        ' convert input to upper case
     SHADOW=(CMD$="Y"): IF NOT SHADOW THEN CMD$="N"              ' set SHADOW variable and print N if input <>Y
     PRINT CMD$                                                  ' display input

        IF NOT SHADOW THEN GOTO DrawTheWindow                    ' no shadow so go draw the window

     GOSUB ClearCommand                                          ' clear lines 23-25 of text
     STARTCOL=35 : LOCATE 23,1,0                                 ' set input column and cursor pos
     Y=1 : CALL CALCATTR(GREY,BLACK,ATTR)                        ' set color
     X=23: A$="Do you want a black shadow (y/n): " : GOSUB Xq    ' prompt
     GOSUB GetInput
     CALL UPCASE(B$)                                             ' convert to all uperr case
        IF B$="Y" THEN
           LOCATE X,1
           CALL CLREOL
           SHADOW=-2
           GOTO DrawTheWindow
        END IF
     LOCATE 23,STARTCOL,1                                        ' set input column and cursor pos
     X=23: Y=1:A$="Enter a foreground color (0-15): " : GOSUB Xq ' prompt
     MAXLEN=2 : GOSUB GetInput                                   ' get up to 2 chars of input
     A=VAL(B$): LOCATE X,STARTCOL : CALL CLREOL                  ' clear input from screen

     LOCATE 23,STARTCOL,1                                        ' position cursor
     X=23: Y=1: A$="Enter a background color (0-15): " : GOSUB Xq' prompt
     GOSUB GetInput                                              ' get input
     B=VAL(B$): LOCATE X,1 : CALL CLREOL                         ' clear entire line
     CALL CALCATTR(A,B,SHADOW)                                   ' set colors for shadow

DrawTheWindow:
     GOSUB ClearCommand                                          ' clear lines 23-25
     STARTCOL=50                                                 ' set input column
     Y=1 : CALL CALCATTR(GREY,BLACK,ATTR)                        ' set prompt color
     X=23: A$="Do you want to overlay the current screen (y/n): " : GOSUB Xq  ' prompt
     GOSUB GetInput                                              ' get input
     LOCATE X,1 : CALL CLREOL                                    ' clear line
     CALL UPCASE(B$)                                             ' convert to all uperr case
     OVERLAY=(INSTR("Y",B$)>0)                                   ' set overlay flag

     GOSUB SaveScreen2                                           ' save the current screen
        IF NOT OVERLAY THEN CLS                                  ' clear screen if told to
     GOSUB WindowManager                                         ' draw the window they designed

     LOCATE 23,1,0 : STARTCOL=35                                 ' locate and set input col
     Y=1 : CALL CALCATTR(GREY,BLACK,ATTR)                        ' set prompt color
     X=23: A$="Do you want to try another (y/n): " : GOSUB Xq    ' ask em
     GOSUB GetInput                                              ' get inpyt
     LOCATE X,1 : CALL CLREOL                                    ' clear line
     CALL UPCASE(B$)                                             ' convert to all uperr case
     GOSUB RestoreScreen2                                        ' restore the screen
        IF B$="Y" THEN GOTO SetUpWindow                          ' do another

Demo2:
     ULR=9 : ULC=10 : LRR=17 : LRC=69 : FRAME=2                  ' set up an new...
     FORE=YELLOW : BACK=BLUE : GROW=-1: LABEL=WHITE              ' window
     LABEL$="ProBas WindowManager"
     CALL CALCATTR(BLUE,WHITE,SHADOW)
     GOSUB WindowManager
     RESTORE DemoData
     Y=11 : CALL CALCATTR(GREY,BLUE,ATTR)
        FOR X=10 TO 16
           READ A$ : GOSUB Xq
        NEXT X
     GOSUB KeyClick
     CLS

     ' This is an example of how to create the window
     ' with the title box that is so popular.  We just
     ' draw the full window, and change one offset to
     ' draw the 'title' box.  Since I'm compulsive
     ' about the way my screens look, and ProBas is
     ' so fast, I added three lines of code to make
     ' the frame unbroken...

     ULR=3 : ULC=4 : LRR=11 : LRC=28
     FORE=GREY : BACK=BLUE  : FRAME=2 : GROW=-1
     GOSUB WindowManager
     LRR=3
     GOSUB WindowManager
     X=LRR+1 : CALL CALCATTR(FORE,BACK,ATTR)
     Y=ULC-1 : A$=CHR$(204) : GOSUB Xq
     Y=LRC+1 : A$=CHR$(185) : GOSUB Xq

     ' That's all there is to it!  Just for display
     ' purposes, let's add some text...

     CALL CALCATTR(WHITE,BACK,ATTR)
     X=ULR : Y=ULC+5 : A$="Monthly Sales" : GOSUB Xq
     CALL CALCATTR(FORE,BACK,ATTR)
     X=X+2 : Y=Y-1 : A$="Display Percentage" : GOSUB Xq
     CALL CALCATTR(BACK,WHITE,ATTR)
     X=X+1 : Y=Y-2 : A$="  Display Y-T-D      " : GOSUB Xq
     CALL CALCATTR(FORE,BACK,ATTR)
     X=X+1 : Y=Y+2 : A$="Display Last Month" : GOSUB Xq
     X=X+1 : A$="Display Quarter"  : GOSUB Xq
     X=X+1 : A$="Display Whatever" : GOSUB Xq
     X=X+1 : A$="Amortization"     : GOSUB Xq
     X=X+1 : A$="Close Window"     : GOSUB Xq

     ' This is another variation on the window
     ' theme, the 'pointer-window'.  We draw
     ' a standard window...

     ULR=7 : ULC=LRC+7 : LRR=9 : LRC=ULC+19
     FORE=BLACK : BACK=YELLOW : FRAME=2
     GOSUB WindowManager

     ' then draw the arrowhead and stem by adding
     ' two more lines of code...

     X=ULR-1 : Y=ULC-4 : CALL CALCATTR(FORE,BACK,ATTR)
     A$=CHR$(17)+CHR$(205)+CHR$(205)+CHR$(203) : GOSUB Xq

     ' and then whatever text we want...

     Y=ULC+1
     X=ULR : A$="Use this option to" : GOSUB Xq
     X=X+1 : A$="display a graph of" : GOSUB Xq
     X=X+1 : A$="year-to-date info." : GOSUB Xq

     ' Here we take the title window a few steps
     ' farther by adding a title box, and dividing
     ' the main box into three columns...

     ULR=14 : ULC=40 : LRR=23 : LRC=70
     FORE=BLUE : BACK=GREY  : FRAME=2
     GOSUB WindowManager
     LRR=15
     GOSUB WindowManager
     X=16 : CALL CALCATTR(FORE,BACK,ATTR)
     Y=39 : A$=CHR$(204) : GOSUB Xq
     Y=71 : A$=CHR$(185) : GOSUB Xq
     ULR=17 : ULC=51 : LRC=59 : LRR=23 : FRAME=4
     GOSUB WindowManager
     X=16
     Y=50 : A$=CHR$(209) : GOSUB Xq
     Y=60 : A$=CHR$(209) : GOSUB Xq
     X=24
     Y=50 : A$=CHR$(207) : GOSUB Xq
     Y=60 : A$=CHR$(207) : GOSUB Xq
     CALL CALCATTR(RED,GREY,ATTR)
     X=14 : Y=42 : A$="With WindowManager, you can" : GOSUB Xq
     X=15 : Y=42 : A$="make windows inside windows" : GOSUB Xq

     ' And end with a small window with a blinking
     ' frame...

     ULR=18 : ULC=5 : LRR=19 : LRC=30 : FRAME=2
     FORE=YELLOW+16  : BACK=MAG : GROW=-1
     GOSUB WindowManager
     Y=6 : CALL CALCATTR(LCYAN,MAG,ATTR)
     X=18 : A$="Press any key to return" : GOSUB Xq
     X=19 : A$=" to the main Demo menu"  : GOSUB Xq

     GOSUB KeyClick
     GOTO Quit

     ' Here's an example of a bare-bones input
     ' routine.   Just what an input routine should
     ' and should not do, what keys do what, and
     ' how certain functions should work is pretty
     ' much a matter of taste.  Some people prefer
     ' DOS edit keys, other's hate them.  We leave it
     ' to you to use the ProBas routines to design
     ' one that suits you.

GetInput:
     B$="" : LL=0 : Y=STARTCOL                                   ' set or clear values
     LOCATE X,Y,1                                                ' make sure cursor is positioned
Gi1: CALL CHECKKEY(MOUSE,CMD,CMD1,LFT,RGT)                       ' get a key
     GOSUB Clock                                                 ' update clock
        IF CMD=0 AND CMD1=0 THEN GOTO Gi1                        ' if no input then try again
        IF CMD=13 THEN PRINT : RETURN                            ' if return then end
        IF CMD1=75 THEN CMD=8                                    ' left arrow
        IF CMD=19 THEN CMD=8                                     ' ^S
        IF CMD=8 THEN GOTO BackSpace                             ' backspace
        IF LL=MAXLEN THEN BEEP : GOTO Gi1                        ' limit length of input
        IF CMD<32 OR CMD>126 THEN GOTO Gi1                       ' accept only valid characters
     LL=LL+1                                                     ' increment len pointer
     B$=B$+CHR$(CMD)                                             ' build string char at a time
     PRINT CHR$(CMD);                                            ' print the char
     Y=Y+1                                                       ' increment column pointer
     GOTO Gi1                                                    ' go for another char

BackSpace:
     LL=LL-1 : IF LL<0 THEN LL=0 : BEEP                          ' decrement length pointer
     B$=LEFT$(B$,LL)                                             ' strip the string
        IF Y<STARTCOL THEN Y=STARTCOL                            ' make sure we don't back up too far
     CALL BKSPACE(X,Y) : LOCATE X,Y,1                            ' do the backspace on screen
     Y=Y-1                                                       ' decrement column pointer
     GOTO Gi1                                                    ' all done

FrameHelp:
     LABEL$="Types of Frames"
     GOSUB HelpWindow
     Y=51: CALL CALCATTR(BLUE,GREY,ATTR)
     X=6 : A$=" Choose from 5 frames:" : GOSUB Xq
     CALL CALCATTR(RED,GREY,ATTR)
     X=8 : A$="0 = No Frame"    : GOSUB Xq
     X=9 : A$="1 = Single line" : GOSUB Xq
     X=10: A$="2 = Double line" : GOSUB Xq
     X=11: A$="3 = Sing horz - doub vert" : GOSUB Xq
     X=12: A$="4 = Doub vert - sing horz" : GOSUB Xq
     X=XX: Y=YY : ATTR=AT
     RETURN

ColorHelp:
     LABEL$="Colors"
     GOSUB HelpWindow
     Y=51: CALL CALCATTR(RED,GREY,ATTR)
     X=5 : A$="0 = Black     1 = Blue"    : GOSUB Xq
     X=6 : A$="2 = Green     3 = Cyan"    : GOSUB Xq
     X=7 : A$="4 = Red       5 = Magenta" : GOSUB Xq
     X=8 : A$="6 = Brown     7 = White"   : GOSUB Xq
     X=9 : A$="8 = Dk Grey   9 = Lt Blue" : GOSUB Xq
     X=10: A$="10= Lt Green  11= Lt Cyan" : GOSUB Xq
     X=11: A$="12= Lt Red    13= Lt Mag"  : GOSUB Xq
     X=12: A$="14= Yellow    15= Hi White": GOSUB Xq
     BRED=RED+16: CALL CALCATTR(BRED,GREY,ATTR)
     X=13: A$="Add 16 for blinking colors": GOSUB Xq
     X=XX: Y=YY : ATTR=AT
     RETURN

HelpWindow:
     XX=X : YY=Y : AT=ATTR
        IF MONO THEN LABEL=BLACK ELSE LABEL=WHITE
     CALL WindowManager(A,B,C,D,E,BLUE,GREY,_
                        F,G,LABEL,LABEL$,PAGE,SCRMODE)
     RETURN

     '--------------------------- data statements ---------------------------

IntroData:
     DATA "The ProBas WindowManager has been"
     DATA "used extensively in this demo and"
     DATA "by  now you  have a fair  idea of"
     DATA "what you can do with it."
     DATA ""
     DATA "This section gives you the chance"
     DATA "to create  some windows  of  your"
     DATA "own. You will be prompted for the"
     DATA "necessary parms."
     DATA "     Press any key to begin"

IntroData1:
     DATA "The WindowManager can also be used"
     DATA "to fill an area of the screen very"
     DATA "quickly. We used the WindowManager"
     DATA "to fill in  this box and to  clear"
     DATA "the area for each page of text."
     DATA ""
     DATA "Unlike many of the other windowing"
     DATA "systems for various languages, the"
     DATA "ProBas WindowManager module has no"
     DATA "preconceived  limits  other  than"
     DATA "your imagination."

IntroData2:
     DATA "The right window shows the various"
     DATA "arguments the WindowManager module"
     DATA "uses. The variables LABEL, LABEL$,"
     DATA "GROW, and SHADOW are optional."
     DATA ""
     DATA "The four position parms  determine"
     DATA "where  the window  will be placed."
     DATA "For example,  the following values"
     DATA "were used to create this window:"
     DATA " ULR=7 : ULC=3 : LRR=20 : LRC=39"
     DATA " BACK=BLUE : GROW=-1
     DATA "    Press any key to continue"

IntroData3:
     DATA "  WindowManager Parameters"
     DATA "ULR        ' upper left row"
     DATA "ULC        ' upper left column"
     DATA "LRR        ' lower right row"
     DATA "LRC        ' lower right column"
     DATA "FRAME      ' the type of frame"
     DATA "FORE       ' color of frame"
     DATA "BACK       ' background color"
     DATA "LABEL      ' color of label"
     DATA "LABEL$     ' text of the label"
     DATA "GROW       ' exploding window"
     DATA "SHADOW     ' shadow"

DemoData:
     DATA "For other effects, you can overlay one window with another"
     DATA "to create fancy input boxes.  Adding a line here or a line"
     DATA "there is so fast with the ProBas XQPRINT routine,  you can"
     DATA "use WindowManager to design highly polished screens."
     DATA ""
     DATA "Press any key to see some examples before returning to the"
     DATA "main menu."

     '------------------- clean up and return to main menu ------------------

Quit:
     GOSUB RestoreScreen                                         ' restore the main menu screen
     RESTART=-1                                                  ' set restart flag
     CHAIN "DEMO"                                                ' do the chain

     '------------------------ standard subroutines -------------------------

WindowManager:
     CALL WindowManager(ULR,ULC,LRR,LRC,FRAME,FORE,BACK,_
                        GROW,SHADOW,LABEL,LABEL$,PAGE,SCRMODE)
     RETURN

SaveScreen:
     CALL DSCRSAVE(VARSEG(SCR1(1)),VARPTR(SCR1(1)),PAGE,SCRMODE)
     RETURN

RestoreScreen:
     CALL DSCRREST(VARSEG(SCR1(1)),VARPTR(SCR1(1)),PAGE,SCRMODE)
     RETURN

SaveScreen2:
     CALL DSCRSAVE(VARSEG(SCR2(1)),VARPTR(SCR2(1)),PAGE,SCRMODE)
     RETURN

RestoreScreen2:
     CALL DSCRREST(VARSEG(SCR2(1)),VARPTR(SCR2(1)),PAGE,SCRMODE)
     RETURN

Xq:  CALL XQPRINT(A$,X,Y,ATTR,PAGE,SCRMODE)
     RETURN

ClearCommand:
     COLOR GREY,BLACK                                            ' default color
     X=23 : Y=1                                                  ' row 23, column 1
        FOR X=25 TO 23 STEP-1                                    ' do it backwards from row 25...
           LOCATE X,Y,0                                          ' locate the cursor pos with it off
           CALL CLREOL                                           ' clear the line
        NEXT X                                                   ' and end on row 23, column 1, ready to display a prompt
     RETURN

KeyClick:
     CLICK=0                                                     ' clear exit flag
        WHILE NOT CLICK                                          ' loop
           GOSUB Clock                                           ' update time display
           CALL CHECKKEY(MOUSE,CMD,CMD1,LFT,RGT)                 ' check for a keypress or mouse click
           IF CMD<>0 OR CMD1<>0 OR LFT<>0 OR RGT<>0 THEN CLICK=-1' did we get one?  if so set exit flag
        WEND                                                     ' loop
     RETURN

Clock:
     XX=X : YY=Y : X=25 : Y=72                                   ' save current x/y value and set to new loc
     CALL XQPRINT(TIME$,X,Y,TIMATTR,PAGE,SCRMODE)                ' update the time every loop
     X=XX : Y=YY                                                 ' restore the x/y values
     RETURN                                                      ' tick tock.

